<?php

/************************************************************************/
/* PHP-NUKE: Advanced Content Management System                         */
/* ============================================                         */
/*                                                             */
/* Copyright (c) 2007 by Francisco Burzi                                */
/* http://phpnuke.org                                                   */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/
//Absolute PHP-Nuke directory
define('PHOENIX_BASE_DIR', dirname(__FILE__) . '/');

// Absolute Phoenix Directory And Includes
define('PHOENIX_INCLUDE_DIR', PHOENIX_BASE_DIR.'includes/');
// End the transaction
if(!defined('END_TRANSACTION')) {
  define('END_TRANSACTION', 2);
}

// Get php version
$phpver = phpversion();

//// Set IRAN Time
if ($phpver >= '5.1.0') {
date_default_timezone_set('Asia/Tehran');
}
/////

// convert superglobals if php is lower then 4.1.0
if ($phpver < '4.1.0') {
  $_GET = $HTTP_GET_VARS;
  $_POST = $HTTP_POST_VARS;
  $_SERVER = $HTTP_SERVER_VARS;
  $_FILES = $HTTP_POST_FILES;
  $_ENV = $HTTP_ENV_VARS;
  if($_SERVER['REQUEST_METHOD'] == "POST") {
    $_REQUEST = $_POST;
  } elseif($_SERVER['REQUEST_METHOD'] == "GET") {
    $_REQUEST = $_GET;
  }
  if(isset($HTTP_COOKIE_VARS)) {
    $_COOKIE = $HTTP_COOKIE_VARS;
  }
  if(isset($HTTP_SESSION_VARS)) {
    $_SESSION = $HTTP_SESSION_VARS;
  }
}

// override old superglobals if php is higher then 4.1.0
if($phpver >= '4.1.0') {
  $HTTP_GET_VARS = $_GET;
  $HTTP_POST_VARS = $_POST;
  $HTTP_SERVER_VARS = $_SERVER;
  $HTTP_POST_FILES = $_FILES;
  $HTTP_ENV_VARS = $_ENV;
  $PHP_SELF = $_SERVER['PHP_SELF'];
  if(isset($_SESSION)) {
    $HTTP_SESSION_VARS = $_SESSION;
  }
  if(isset($_COOKIE)) {
    $HTTP_COOKIE_VARS= $_COOKIE;
  }
}

// After doing those superglobals we can now use one
// and check if this file isnt being accessed directly
if (stristr(htmlentities($_SERVER['PHP_SELF']), "mainfile.php")) {
    header("Location: index.php");
    exit();
}

if (!function_exists("floatval")) {
    function floatval($inputval) {
        return (float)$inputval;
    }
}

if ($phpver >= '4.0.4pl1' && isset($_SERVER['HTTP_USER_AGENT']) && strstr($_SERVER['HTTP_USER_AGENT'],'compatible')) {
	if (extension_loaded('zlib')) {
    	@ob_end_clean();
    	@ob_start('ob_gzhandler');
  	}
} elseif ($phpver > '4.0' && isset($_SERVER['HTTP_ACCEPT_ENCODING']) && !empty($_SERVER['HTTP_ACCEPT_ENCODING'])) {
  	if (strstr($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip')) {
    	if (extension_loaded('zlib')) {
      		$do_gzip_compress = true;
      		@ob_start(array('ob_gzhandler',5));
      		@ob_implicit_flush(0);
      		if (@ereg("MSIE", $_SERVER['HTTP_USER_AGENT'])) {
				header('Content-Encoding: gzip');
      		}
    	}
  	}
}

if($phpver >= '5.4.0'){
	$methods = array("_GET","_POST","_COOKIE");
	foreach($methods as $method){
		foreach($$method as $method_key => $method_val){
			$$method_key = $method_val;
		}
	}
}else{
	if (!ini_get('register_globals')) {
		@import_request_variables("GPC", "");
	}
}

// This block of code makes sure $admin and $user are COOKIES
if((isset($admin) && $admin != $_COOKIE['admin']) OR (isset($user) && $user != $_COOKIE['user'])) {
	die("Illegal Operation");
}

// We want to use the function stripos,
// but thats only available since PHP5.
// So we cloned the function...
if(!function_exists('stripos')) {
  function stripos_clone($haystack, $needle, $offset=0) {
    $return = strpos(strtoupper($haystack), strtoupper($needle), $offset);
  if ($return === false) {
    return false;
    } else {
    return true;
    }
  }
} else {
// But when this is PHP5, we use the original function
  function stripos_clone($haystack, $needle, $offset=0) {
    $return = stripos($haystack, $needle, $offset=0);
  if ($return === false) {
    return false;
    } else {
    return true;
    }
  }
}

if(isset($admin) && $admin == $_COOKIE['admin'])
{
	$admin = base64_decode($admin);
	$admin = addslashes($admin);
	$admin = base64_encode($admin);
}

if(isset($user) && $user == $_COOKIE['user'])
{
	$user = base64_decode($user);
	$user = addslashes($user);
	$user = base64_encode($user);
}

// Die message for not allowed HTML tags
$htmltags = "<center><img src=\"images/logo.gif\"><br><br><b>";
$htmltags .= "The html tags you attempted to use are not allowed</b><br><br>";
$htmltags .= "[ <a href=\"javascript:history.go(-1)\"><b>Go Back</b></a> ]</center>";

if (!defined('ADMIN_FILE')) {
 foreach ($_GET as $sec_key => $secvalue) {
 if((@eregi("<[^>]*script*\"?[^>]*", $secvalue)) ||
  (@eregi("<[^>]*object*\"?[^>]*", $secvalue)) ||
  (@eregi("<[^>]*iframe*\"?[^>]*", $secvalue)) ||
  (@eregi("<[^>]*applet*\"?[^>]*", $secvalue)) ||
  (@eregi("<[^>]*meta*\"?[^>]*", $secvalue)) ||
  (@eregi("<[^>]*style*\"?[^>]*", $secvalue)) ||
  (@eregi("<[^>]*form*\"?[^>]*", $secvalue)) ||
  (@eregi("<[^>]*img*\"?[^>]*", $secvalue)) ||
  (@eregi("<[^>]*onmouseover *\"?[^>]*", $secvalue)) ||
  (@eregi("<[^>]*body *\"?[^>]*", $secvalue)) ||
  (@eregi("\([^>]*\"?[^)]*\)", $secvalue)) ||
  (@eregi("\"", $secvalue)) ||
  (@eregi("forum_admin", $sec_key)) ||
  (@eregi("inside_mod", $sec_key)))
  {
   die ($htmltags);
  }
}

 foreach ($_POST as $secvalue) {
  if ((@eregi("<[^>]*iframe*\"?[^>]*", $secvalue)) ||
  (@eregi("<[^>]*object*\"?[^>]*", $secvalue)) ||
  (@eregi("<[^>]*applet*\"?[^>]*", $secvalue)) ||
  (@eregi("<[^>]*meta*\"?[^>]*", $secvalue)) ||
  (@eregi("<[^>]*onmouseover*\"?[^>]*", $secvalue)) ||
  (@eregi("<[^>]script*\"?[^>]*", $secvalue)) ||
  (@eregi("<[^>]*body*\"?[^>]*", $secvalue)) ||
  (@eregi("<[^>]style*\"?[^>]*", $secvalue))) {
   die ($htmltags);
  }
 }
}

// Define the INCLUDE PATH
if(defined('FORUM_ADMIN')) {
	define('INCLUDE_PATH', '../../../');
} elseif(defined('INSIDE_MOD')) {
	define('INCLUDE_PATH', '../../');
} else {
	define('INCLUDE_PATH', './');
}

// Include the required files
@require_once(INCLUDE_PATH."config.php");

if(!$dbname) {
    die("<br><br><center><img src=images/logo.gif><br><br><b>There seems that PHP-Nuke isn't installed yet.<br>(The values in config.php file are the default ones)<br><br>You can proceed with the <a href='./install/index.php'>web installation</a> now.</center></b>");
}

@require_once(INCLUDE_PATH."db/db.php");

/* FOLLOWING TWO LINES ARE DEPRECATED BUT ARE HERE FOR OLD MODULES COMPATIBILITY */
/* PLEASE START USING THE NEW SQL ABSTRACTION LAYER. SEE MODULES DOC FOR DETAILS */
@require_once(INCLUDE_PATH."includes/sql_layer.php");
$dbi = sql_connect($dbhost, $dbuname, $dbpass, $dbname);

@require_once(INCLUDE_PATH."includes/ipban.php");
if (file_exists(INCLUDE_PATH."includes/custom_files/custom_mainfile.php")) {
	@include_once(INCLUDE_PATH."includes/custom_files/custom_mainfile.php");
}

if (!defined('FORUM_ADMIN')) {
if(empty($admin_file)) {
   	die ("You must set a value for admin_file in config.php");
} elseif (!empty($admin_file) && !file_exists(INCLUDE_PATH.$admin_file.".php")) {
   	die ("The admin_file you defined in config.php does not exist");
  }
}

// Error reporting, to be set in config.php

error_reporting(E_ALL^E_NOTICE);


define('NUKE_FILE', true);
//$row = $db->sql_fetchrow($db->sql_query("SET NAMES `utf8`"));
$row = $db->sql_fetchrow($db->sql_query("SELECT * FROM ".$prefix."_config"));
$sitename = filter($row['sitename'], "nohtml");
$nukeurl = filter($row['nukeurl'], "nohtml");
$site_logo = filter($row['site_logo'], "nohtml");
$slogan = filter($row['slogan'], "nohtml");
$startdate = filter($row['startdate'], "nohtml");
$adminmail = filter($row['adminmail'], "nohtml");
$anonpost = intval($row['anonpost']);
$Default_Theme = filter($row['Default_Theme'], "nohtml");
$foot1 = stripslashes($row['foot1']);
$foot2 = stripslashes($row['foot2']);
$foot3 = stripslashes($row['foot3']);
$overwrite_theme = $row['overwrite_theme'];
$commentlimit = intval($row['commentlimit']);
$anonymous = filter($row['anonymous'], "nohtml");
$minpass = intval($row['minpass']);
$pollcomm = intval($row['pollcomm']);
$articlecomm = intval($row['articlecomm']);
$contentcom = intval($row['contentcom']);
$staticcomm = intval($row['staticcomm']);
$productscomm = intval($row['productscomm']);
$broadcast_msg = intval($row['broadcast_msg']);
$my_headlines = intval($row['my_headlines']);
$top = intval($row['top']);
$storyhome = intval($row['storyhome']);
$contenthome = intval($row['contenthome']);
$producthome = intval($row['producthome']);
$user_news = intval($row['user_news']);
$oldnum = intval($row['oldnum']);
$ultramode = intval($row['ultramode']);
$banners = intval($row['banners']);
$backend_title = filter($row['backend_title'], "nohtml");
$backend_language = filter($row['backend_language'], "nohtml");
$language = filter($row['language'], "nohtml");
$locale = filter($row['locale'], "nohtml");
$align = filter($row['align'], "nohtml");
$multilingual = intval($row['multilingual']);
$useflags = intval($row['useflags']);
$notify = intval($row['notify']);
$notify_subject = filter($row['notify_subject'], "nohtml");
$notify_message = filter($row['notify_message'], "nohtml");
$notify_from = filter($row['notify_from'], "nohtml");
$moderate = intval($row['moderate']);
$admingraphic = intval($row['admingraphic']);
$httpref = intval($row['httpref']);
$httprefmax = intval($row['httprefmax']);
$CensorMode = intval($row['CensorMode']);
$CensorReplace = filter($row['CensorReplace'], "nohtml");
$copyright = filter($row['copyright']);
$Version_Num = floatval($row['Version_Num']);
$domain = str_replace("http://", "", $nukeurl);
$gfx_chk = intval($row['gfx_chk']);
$display_errors = filter($row['display_errors']);
$gtset = filter($row['gtset']);
$nuke_editor = intval($row['nuke_editor']);
$mtime = microtime();
$mtime = explode(" ",$mtime);
$mtime = $mtime[1] + $mtime[0];
$start_time = $mtime;
$pagetitle = "";
$copyright = base64_decode(base64_decode(base64_decode($copyright)));
$gtset = intval($row['gtset']);
$userurl = intval($row['userurl']);
$show_links = intval($row['show_links']);
$show_effect = intval($row['show_effect']);
$datetype = intval($row['datetype']);
$votetype = intval($row['votetype']);
$preloader = intval($row['preloader']);
$comment_editor = intval($row['comment_editor']);
$confirm_need = intval($row['confirm_need']);
$sitecookies = filter($row['sitecookies']);

if($display_errors) {
  @ini_set('display_errors', 1);
} else {
  @ini_set('display_errors', 0);
}


function nuke_set_cookie($name, $cookiedata, $cookietime){
	global $sitecookies;
	if($cookiedata == false){
		$cookietime = time()-3600;
	}
	$name_data = rawurlencode($name) . '=' . rawurlencode($cookiedata);
	$expire = gmdate('D, d-M-Y H:i:s \\G\\M\\T', $cookietime);
	@header('Set-Cookie: '.$name_data.(($cookietime) ? '; expires='.$expire : '').'; path='.$sitecookies.'; HttpOnly', false);
}
// Request URL Redirect To Nuke Url
$Req_Protocol 	= strpos(strtolower($_SERVER['SERVER_PROTOCOL']),'https') === FALSE ? 'http' : 'https';
$Req_Host     	= $_SERVER['HTTP_HOST'];
$Req_Uri		= $_SERVER['REQUEST_URI'];
$Req_Path		= $_SERVER['SCRIPT_NAME'];
$Req_URL		= $Req_Protocol . '://' . $Req_Host . $Req_Path;
$Req_URI		= $Req_Protocol . '://' . $Req_Host . $Req_Uri;
$Req_Filename 	= substr($_SERVER["SCRIPT_NAME"],strrpos($_SERVER["SCRIPT_NAME"],"/")+1);
$filenamepos 	= strpos($Req_URL,$Req_Filename);
$Req_URL 		= substr($Req_URL,0,$filenamepos);
$Redirect_Url 	= substr($Req_URI,strlen($Req_URL),strlen($Req_URL));

/*
if($Version_Num == "8.3")
{
	if($Req_URL != $nukeurl)
	{
		header("Location: ".$nukeurl . $Redirect_Url,TRUE,301);
		exit;
	}
}else
{
	$db->sql_query("UPDATE ".$prefix."_config SET nukeurl='".$Req_URL."' LIMIT 1");
	if($Req_Filename != 'upgrade.php')
	{
		header("Location: upgrade.php",TRUE,301);
		exit;
	}
}
*/
$nukeurl = $Req_URL;
/******************END****************/

if((isset($newtype)) && ($newtype == "nonewtype")){
nuke_set_cookie("type",false,'');
header("location: index.php");
}
include("language/alphabets.php");
///////////////////
    if ((isset($newtype)) && ($newtype != "nonewtype")) {
		$newtype = intval($newtype);
		nuke_set_cookie("type",$newtype,time()+31536000);
		$datetype = $newtype;
	}elseif(isset($type)){
		$datetype = $type;
	}
//////////////////

if(isset($newlang) && $newlang == "nolang"){
nuke_set_cookie("nukelang",false,'');
nuke_set_cookie("align2",false,'');
header("location: index.php");
}

if (!defined('FORUM_ADMIN')) {
    if ((isset($newlang)) AND (!stristr($newlang,"."))) {
		$newlang = filter($newlang, "nohtml");
		$align = filter($alignment, "nohtml");	
		if (file_exists("language/$newlang/lang-".$newlang.".php")) {
			nuke_set_cookie("nukelang",$newlang,time()+31536000);
			nuke_set_cookie("align2",$align,time()+31536000);
			include_once("language/$newlang/lang-".$newlang.".php");
			$currentlang = $newlang;
		} else {
			nuke_set_cookie("nukelang",$language,time()+31536000);
			nuke_set_cookie("align2",$align,time()+31536000);
			include_once("language/$language/lang-".$language.".php");
			$currentlang = $language;
		}
	} elseif (isset($nukelang)) {
		$nukelang = filter($nukelang, "nohtml");
		if(isset($align2)){
		$align = filter($align2, "nohtml");
		}
		include_once("language/$nukelang/lang-".$nukelang.".php");
		$currentlang = $nukelang;
	} else {
		nuke_set_cookie("nukelang",$language,time()+31536000);
		include_once("language/$language/lang-".$language.".php");
		$currentlang = $language;
	}
}
if($align == ""){
	$align = "rtl";
}

function makePass($cid) {
	global $gfx_chk;
	if (extension_loaded("gd")) {
		$makepass .= "
		<br /><img src=\"includes/captcha/securimage_show.php?sid=".md5(uniqid(time()))."&id=$cid\" onclick=\"document.getElementById('capchaimage".$cid."').src = 'includes/captcha/securimage_show.php?sid=' + Math.random()+'&id=$cid'; return false\" id=\"capchaimage".$cid."\" style=\"cursor: pointer;\" title=\""._CLICKFORREFRESH."\" alt=\""._SECURITYCODE."\" /><br /><br /><input name=\"security_code\" id=\"security_code\" type=\"text\"><input name=\"security_code_id\" type=\"hidden\" value=\"$cid\">";
	}
	return($makepass);
}

if($align == "rtl"){
	$textalign1 = "right";
	$textalign2 = "left";
	define("RTL_TEXT",true);
}else{
	$textalign1 = "left";
	$textalign2 = "right";
	define("LTR_TEXT",true);
}

function get_lang($module) {
   global $currentlang, $language, $ThemeSel, $align;
   if ($module == "admin" AND $module != "Forums") {
      if (file_exists("language/".$currentlang."/admin/lang-".$currentlang.".php")) {
         include_once("language/".$currentlang."/admin/lang-".$currentlang.".php");
      } elseif (file_exists("language/".$currentlang."/admin/lang-".$language.".php")) {
         include_once("language/".$currentlang."/admin/lang-".$language.".php");
      }
   } else {
      if (file_exists("modules/$module/language/lang-".$currentlang.".php")) {
         include_once("modules/$module/language/lang-".$currentlang.".php");
      } elseif (file_exists("modules/$module/language/lang-".$language.".php")) {
         include_once("modules/$module/language/lang-".$language.".php");
      }
   }
 
}

function theme_lang() {
   global $currentlang, $language, $align,$ThemeSel;
@include_once("themes/$ThemeSel/language/lang-".$currentlang.".php");
}

@theme_lang();

function is_admin($admin) {
    static $adminSave; 
    if (!$admin) { return 0; }
    if (isset($adminSave)) return $adminSave;
    if (!is_array($admin)) {
        $admin = base64_decode($admin);
        $admin = addslashes($admin);
        $admin = explode(':', $admin);
    }
    $aid = $admin[0];
    $pwd = $admin[1];
    $aid = substr(addslashes($aid), 0, 25);
    if (!empty($aid) && !empty($pwd)) {
        global $prefix, $db;
        $sql = "SELECT pwd FROM ".$prefix."_authors WHERE aid='$aid'";
        $result = $db->sql_query($sql);
        $pass = $db->sql_fetchrow($result);
        $db->sql_freeresult($result);
        if ($pass[0] == $pwd && !empty($pass[0])) {
        	return $adminSave = 1;
        }
    }
    return $adminSave = 0;
}

function is_user($user) {
    if (!$user) { return 0; }
    static $userSave; 
    if (isset($userSave)) return $userSave;
    if (!is_array($user)) {
        $user = base64_decode($user);
        $user = addslashes($user);
        $user = explode(":", $user);
    }
    $uid = $user[0];
    $pwd = $user[2];
    $uid = intval($uid);
    if (!empty($uid) AND !empty($pwd)) {
        global $db, $user_prefix;
        $sql = "SELECT user_password FROM ".$user_prefix."_users WHERE user_id='$uid'";
        $result = $db->sql_query($sql);
        list($row) = $db->sql_fetchrow($result);
        $db->sql_freeresult($result);
        if ($row == $pwd && !empty($row)) { 
        	return $userSave = 1;
        }
    }
    return $userSave = 0;
}

function is_group($user, $name) {
          global $prefix, $db, $user_prefix, $cookie, $user;
     if (is_user($user)) {
          if(!is_array($user)) {
          $cookie = cookiedecode($user);
          $uid = intval($cookie[0]);
          } else {
          $uid = intval($user[0]);
          }
          $result = $db->sql_query("SELECT points FROM ".$user_prefix."_users WHERE user_id='$uid'");
          $row = $db->sql_fetchrow($result);
          $points = intval($row['points']);
          $db->sql_freeresult($result);
          $result2 = $db->sql_query("SELECT mod_group FROM ".$prefix."_modules WHERE title='$name'");
          $row2 = $db->sql_fetchrow($result2);
          $mod_group = intval($row2['mod_group']);
          $db->sql_freeresult($result2);
          $result3 = $db->sql_query("SELECT points FROM ".$prefix."_groups WHERE id='$mod_group'");
          $row3 = $db->sql_fetchrow($result3);
          $grp = intval($row3['points']);
          $db->sql_freeresult($result3);
          if (($points >= 0 AND $points >= $grp) OR $mod_group == 0) {
        	return 1;
          }
     }
     return 0;
}

$postString = "";
foreach ($_POST as $postkey => $postvalue) {
    if ($postString > "") {
     $postString .= "&".$postkey."=".$postvalue;
    } else {
     $postString .= $postkey."=".$postvalue;
    }
}
str_replace("%09", "%20", $postString);
$postString_64 = base64_decode($postString);
if ((!isset($admin) OR (isset($admin) AND !is_admin($admin))) AND (stristr($postString,'%20union%20')) OR (stristr($postString,'*/union/*')) OR (stristr($postString,' union ')) OR (stristr($postString_64,'%20union%20')) OR (stristr($postString_64,'*/union/*')) OR (stristr($postString_64,' union ')) OR (stristr($postString_64,'+union+')) OR (stristr($postString,'http-equiv')) OR (stristr($postString_64,'http-equiv')) OR (stristr($postString,'alert(')) OR (stristr($postString_64,'alert(')) OR (stristr($postString,'javascript:')) OR (stristr($postString_64,'javascript:')) OR (stristr($postString,'document.cookie')) OR (stristr($postString_64,'document.cookie')) OR (stristr($postString,'onmouseover=')) OR (stristr($postString_64,'onmouseover=')) OR (stristr($postString,'document.location')) OR (stristr($postString_64,'document.location'))) {
header("Location: index.php");
die();
}

// Additional security (Union, CLike, XSS)
//Union Tap
//Copyright Zhen-Xjell 2004 http://nukecops.com
//Beta 3 Code to prevent UNION SQL Injections
  unset($matches);
  unset($loc);
  if(isset($_SERVER['QUERY_STRING'])) {
    if (@preg_match("/([OdWo5NIbpuU4V2iJT0n]{5}) /", rawurldecode($loc=$_SERVER['QUERY_STRING']), $matches)) {
      die('Illegal Operation');
    }
  }
  if(!isset($admin) OR (isset($admin) AND !is_admin($admin))) {
    $queryString = $_SERVER['QUERY_STRING'];
	if (($_SERVER['PHP_SELF'] != "/index.php") OR !isset($url))
	{
	   if (stristr($queryString,'http://')) die('Illegal Operation');
	}
    if ((stristr($queryString,'%20union%20')) OR (stristr($queryString,'%2f%2a')) OR (stristr($queryString,'%2f*')) OR (stristr($queryString,'/*')) OR (stristr($queryString,'*/union/*')) OR (stristr($queryString,'c2nyaxb0')) OR (stristr($queryString,'+union+'))  OR ((stristr($queryString,'cmd=')) AND (!stristr($queryString,'&cmd'))) OR ((stristr($queryString,'exec')) AND (!stristr($queryString,'execu'))) OR (stristr($queryString,'concat'))) {
      die('Illegal Operation');
    }
  }

function update_points($id,$uid=false) {
    global $user_prefix, $prefix, $db, $user;
    if (is_user($user)) {
        if(!is_array($user)) {
            $cookie = cookiedecode($user);
            $username = trim($cookie[0]);
        } else {
            $username = trim($user[0]);
        }
		$id = intval($id);
		$result = $db->sql_query('SELECT points FROM '.$prefix.'_groups_points WHERE id=\''.$id.'\'');
		$row = $db->sql_fetchrow($result);
		$points = intval($row['points']);
		if($points > 0){
			if(isset($uid)){
				$db->sql_query('UPDATE '.$user_prefix.'_users SET points=points+'.$points.' WHERE user_id=\''.$uid.'\'');
			}else{
				$db->sql_query('UPDATE '.$user_prefix.'_users SET points=points+'.$points.' WHERE user_id=\''.$username.'\'');
			}
		}
    }
}

function title($text) {
	if(defined("ADMIN_FILE")){
		OpenAdminTable();
	}else{
		OpenTable();
	}
echo "<center><span class=\"title\"><strong>$text</strong></span></center>";
	if(defined("ADMIN_FILE")){
		CloseAdminTable();
	}else{
		CloseTable();
	}
	echo "<br>";
}

function is_active($module) {
    global $prefix, $db;
    static $save;
    if (is_array($save)) {
        if (isset($save[$module])) return ($save[$module]);
        return 0;
    }
    $sql = "SELECT title FROM ".$prefix."_modules WHERE active=1";
    $result = $db->sql_query($sql);
    while ($row = $db->sql_fetchrow($result)) {
        $save[$row[0]] = 1;
    }
    $db->sql_freeresult($result);
    if (isset($save[$module])) return ($save[$module]);
    return 0;
}

function render_blocks($side, $blockfile, $title, $content, $bid, $url, $themeview, $themetype) { //MOHSEN
	if(!defined('BLOCK_FILE')) {
	  define('BLOCK_FILE', true);
	}
	if (empty($url)) {
		if (empty($blockfile)) {
			if ($side == "c") {
				themecenterbox($title, $content, $themeview, $themetype); //MOHSEN
			} elseif ($side == "d") {
				themecenterbox($title, $content, $themeview, $themetype); //MOHSEN
			} else {
				themesidebox($title, $content, $themeview, $themetype); //MOHSEN
			}
		} else {
			if ($side == "c") {
				blockfileinc($title, $blockfile, $themeview, $themetype, 1); //MOHSEN
			} elseif ($side == "d") {
				blockfileinc($title, $blockfile, $themeview, $themetype, 1); //MOHSEN
			} else {
				blockfileinc($title, $blockfile, $themeview, $themetype); //MOHSEN
			}
		}
	} else {
		if ($side == "c" OR $side == "d") {
			headlines($bid,1, $themetype);
		} else {
			headlines($bid, $themetype);
		}
	}
}

function blocks($side) {
	global $storynum, $prefix, $multilingual, $currentlang, $db, $admin, $user;
	if ($multilingual == 1) {
		$querylang = "AND (blanguage='$currentlang' OR blanguage='')";
	} else {
		$querylang = "";
	}
	if (strtolower($side[0]) == "l") {
		$pos = "l";
	} elseif (strtolower($side[0]) == "r") {
		$pos = "r";
	}  elseif (strtolower($side[0]) == "c") {
		$pos = "c";
	} elseif  (strtolower($side[0]) == "d") {
		$pos = "d";
	}
	$side = $pos;
	$sql = "SELECT * FROM ".$prefix."_blocks WHERE bposition='$pos' AND active='1' $querylang ORDER BY weight ASC";
	$result = $db->sql_query($sql);
	while($row = $db->sql_fetchrow($result)) {
		$bid = intval($row['bid']);
		if ($multilingual == 1) {
		$resultf = $db->sql_query("SELECT * FROM ".$prefix."_blocks_titles WHERE (bid='$bid' AND lang='$currentlang')");
		$rowf = $db->sql_fetchrow($resultf);
		$rown = $db->sql_numrows($resultf);
		if($rown > 0){
		$title =  filter($rowf['btitle'], "nohtml");
		}else{
		$title = filter($row['title'], "nohtml");
		}
		}else{
		$title = filter($row['title'], "nohtml");
		}
		$content = stripslashes($row['content']);
		$url = filter($row['url'], "nohtml");
		$blockfile = filter($row['blockfile'], "nohtml");
		$view = intval($row['view']);
		$themeview = $row['themeview']; //MOHSEN
		$expire = intval($row['expire']);
		$action = filter($row['action'], "nohtml");
		$action = substr($action, 0,1);
		$now = time();
		$sub = intval($row['subscription']);
		$themetype = intval($row['blocks_sides']);
		if ($sub == 0 OR ($sub == 1 AND !paid())) {
			if ($expire != 0 AND $expire <= $now) {
				if ($action == "d") {
					$db->sql_query("UPDATE ".$prefix."_blocks SET active='0', expire='0' WHERE bid='$bid'");
					return;
				} elseif ($action == "r") {
					$db->sql_query("DELETE FROM ".$prefix."_blocks WHERE bid='$bid'");
					return;
				}
			}
			if ($row['bkey'] == "admin") {
				adminblock();
			} elseif ($row['bkey'] == "userbox") {
				userblock();
			} elseif (empty($row['bkey'])) {
				if ($view == 0) {
					render_blocks($side, $blockfile, $title, $content, $bid, $url, $themeview, $themetype); //MOHSEN
				} elseif ($view == 1 AND is_user($user) || is_admin($admin)) {
					render_blocks($side, $blockfile, $title, $content, $bid, $url, $themeview, $themetype); //MOHSEN
				} elseif ($view == 2 AND is_admin($admin)) {
					render_blocks($side, $blockfile, $title, $content, $bid, $url, $themeview, $themetype); //MOHSEN
				} elseif ($view == 3 AND !is_user($user) || is_admin($admin)) {
					render_blocks($side, $blockfile, $title, $content, $bid, $url, $themeview, $themetype); //MOHSEN
				}
			}
		}
	}
	$db->sql_freeresult($result);
}

function message_box() {
	global $bgcolor1, $bgcolor2, $user, $admin, $cookie, $textcolor2, $prefix, $multilingual, $currentlang, $db, $admin_file;
	if ($multilingual == 1) {
		$querylang = "AND (mlanguage='$currentlang' OR mlanguage='')";
	} else {
		$querylang = "";
	}
	$result = $db->sql_query("SELECT mid, title, content, date, expire, view FROM ".$prefix."_message WHERE active='1' $querylang");
	if ($numrows = $db->sql_numrows($result) == 0) {
		return;
	} else {
		while ($row = $db->sql_fetchrow($result)) {
			$mid = intval($row['mid']);
			$title = filter($row['title'], "nohtml");
			$content = stripslashes($row['content']);
			$mdate = $row['date'];
			$expire = intval($row['expire']);
			$view = intval($row['view']);
			if (!empty($title) && !empty($content)) {
				if ($expire == 0) {
					$remain = _UNLIMITED;
				} else {
					$etime = (($mdate+$expire)-time())/3600;
					$etime = (int)$etime;
					if ($etime < 1) {
						$remain = _EXPIRELESSHOUR;
					} else {
						$remain = ""._EXPIREIN." $etime "._HOURS."";
					}
				}
				if ($view == 5 AND paid()) {
					if (is_admin($admin)) {
						$content .= "<br><br><center><font class=\"content\">[ "._MVIEWSUBUSERS." - $remain - <a href=\"".$admin_file.".php?op=editmsg&amp;mid=$mid\">"._EDIT."</a> ]</font></center>";
					}
					themecenterbox($title, $content, $themeview=1, $themetype=(-1));
				} elseif ($view == 4 AND is_admin($admin)) {
					$content .= "<br><br><center><font class=\"content\">[ "._MVIEWADMIN." - $remain - <a href=\"".$admin_file.".php?op=editmsg&amp;mid=$mid\">"._EDIT."</a> ]</font></center>";
                                        themecenterbox($title, $content, $themeview=1, $themetype=(-1));
				} elseif ($view == 3 AND is_user($user) || is_admin($admin)) {
					if (is_admin($admin)) {
						$content .= "<br><br><center><font class=\"content\">[ "._MVIEWUSERS." - $remain - <a href=\"".$admin_file.".php?op=editmsg&amp;mid=$mid\">"._EDIT."</a> ]</font></center>";
					}
					themecenterbox($title, $content, $themeview=1, $themetype=(-1));
				} elseif ($view == 2 AND !is_user($user) || is_admin($admin)) {
					if (is_admin($admin)) {
						$content .= "<br><br><center><font class=\"content\">[ "._MVIEWANON." - $remain - <a href=\"".$admin_file.".php?op=editmsg&amp;mid=$mid\">"._EDIT."</a> ]</font></center>";
					}
					themecenterbox($title, $content, $themeview=1, $themetype=(-1));
				} elseif ($view == 1) {
					if (is_admin($admin)) {
						$content .= "<br><br><center><font class=\"content\">[ "._MVIEWALL." - $remain - <a href=\"".$admin_file.".php?op=editmsg&amp;mid=$mid\">"._EDIT."</a> ]</font></center>";
					}
					themecenterbox($title, $content, $themeview=1, $themetype=(-1));
				}
				if ($expire != 0) {
					$past = time()-$expire;
					if ($mdate < $past) {
						$db->sql_query("UPDATE ".$prefix."_message SET active='0' WHERE mid='$mid'");
					}
				}
			}
		}
	}
}

function online() {
  global $user, $cookie, $prefix, $db;
  $ip = $_SERVER['REMOTE_ADDR'];
  if (is_user($user)) {
    cookiedecode($user);
    $uname = $cookie[1];
    $guest = 0;
  } else {
    $uname = $ip;
    $guest = 1;
  }
  $time_remain = intval(file_get_contents("time.txt"));
  $past = time()-$time_remain;
  $sql = "DELETE FROM ".$prefix."_session WHERE time < '$past'";
  $db->sql_query($sql);
  $sql = "SELECT time FROM ".$prefix."_session WHERE uname='".addslashes($uname)."'";
  $result = $db->sql_query($sql);
  $ctime = time();
  if (!empty($uname)) {
    $uname = substr($uname, 0,25);
    $row = $db->sql_fetchrow($result);
    if ($row) {
      $db->sql_query("UPDATE ".$prefix."_session SET uname='".addslashes($uname)."', time='$ctime', host_addr='$ip', guest='$guest' WHERE uname='".addslashes($uname)."'");
    } else {
      $db->sql_query("INSERT INTO ".$prefix."_session (uname, time, host_addr, guest) VALUES ('".addslashes($uname)."', '$ctime', '$ip', '$guest')");
    }
  }
  $db->sql_freeresult($result);
}

function blockfileinc($title, $blockfile, $themeview, $themetype, $side=0) { //MOHSEN
	$blockfiletitle = $title;
	$file = file_exists("blocks/".$blockfile."");
	if (!$file) {
		$content = _BLOCKPROBLEM;
	} else {
		include("blocks/".$blockfile."");
	}
	if (empty($content)) {
		$content = _BLOCKPROBLEM2;
	}

	if ($side == 1) {
		themecenterbox($blockfiletitle, $content, $themeview=1, $themetype); //MOHSEN
	} elseif ($side == 2) {
		themecenterbox($blockfiletitle, $content, $themeview=1, $themetype); //MOHSEN
	} else {
		themesidebox($blockfiletitle, $content, $themeview=1, $themetype); //MOHSEN
	}
}

function selectlanguage() {
	global $useflags, $currentlang,$align;
	if ($useflags == 1) {
		$title = _SELECTLANGUAGE;
		$content = "<center><font class=\"content\">"._SELECTGUILANG."<br><br>";
		$langdir = dir("language");
		while($func=$langdir->read()) {
		/*if(substr($func, 0, 5) == "lang-") {
			$menulist .= "$func ";
		}*/
		if($func!="." && $func!=".."&&$func!="index.html" && $func!=".htaccess"){
			$menulist .= "$func ";
		}
		}
		closedir($langdir->handle);
		$menulist = explode(" ", $menulist);
		sort($menulist);
		$content = "<a href=\"index.php?newlang=$nolang\"><img src=\"images/language/flag-deflang.png\" border=\"0\" alt=\"".DEFLANG."\" title=\"".DEFLANG."\" hspace=\"3\" vspace=\"3\"></a><br>";
		for ($i=0; $i < sizeof($menulist); $i++) {
			if($menulist[$i]!="") {
				$tl = str_replace("lang-","",$menulist[$i]);
				$tl = str_replace(".php","",$tl);
				$altlang = ucfirst($tl);
				$content .= "<a href=\"index.php?newlang=".$tl."&alignment=$align\"><img src=\"images/language/flag-".$tl.".png\" border=\"0\" alt=\"$altlang\" title=\"$altlang\" hspace=\"3\" vspace=\"3\"></a> ";
			}
		}
		$content .= "</font></center>";
		themesidebox($title, $content, $themeview, $themetype);
	} else {
		$title = _SELECTLANGUAGE;
		$content = "<center><font class=\"content\">"._SELECTGUILANG."<br><br></font>";
		$content .= "<form action=\"index.php\" method=\"get\"><select name=\"newlanguage\" onChange=\"top.location.href=this.options[this.selectedIndex].value\">
		<option value=\"\">"._NOLANG."</option>
		<option value=\"index.php?newlang=nolang\">"._DEFLANG."</option>
		";
		$handle=opendir('language');
		$languageslist = "";
		while ($file = readdir($handle)) {
			/*if (@ereg("^lang\-(.+)\.php", $file, $matches)) {//iman edit
				$langFound = $matches[1];
				$languageslist .= "$langFound ";
			}*/
			if($file!="." && $file!=".."&&$file!="index.html" && $file!=".htaccess"){
			$languageslist .= "$file ";
			}
		}
		closedir($handle);
		$languageslist = explode(" ", $languageslist);
		sort($languageslist);
		for ($i=0; $i < sizeof($languageslist); $i++) {
			if($languageslist[$i]!="") {
				$content .= "<option value=\"index.php?newlang=".$languageslist[$i]."&alignment=$align\" ";
				if($languageslist[$i]==$currentlang) $content .= " selected";
				$content .= ">".ucfirst($languageslist[$i])."</option>\n";
			}
		}
		$content .= "</select></form></center>";
		themesidebox($title, $content, $themeview, $themetype);
	}
}

function ultramode() {
	global $prefix, $db;
	$ultra = "ultramode.txt";
	$file = fopen($ultra, "w");
	fwrite($file, "General purpose self-explanatory file with news headlines\n");
	$sql = "SELECT s.sid, s.catid, s.aid, s.title, s.time, s.hometext, s.comments, s.topic, t.topictext, t.topicimage FROM ".$prefix."_stories s LEFT JOIN ".$prefix."_topics t ON t.topicid = s.topic WHERE s.ihome = '0' ".$querylang." ORDER BY s.time DESC LIMIT 0,10";
	$result = $db->sql_query($sql);
	while ($row = $db->sql_fetchrow($result)) {
		$rsid = intval($row['sid']);
		$raid = filter($row['aid'], "nohtml");
		$rtitle = filter($row['title'], "nohtml");
		$rtime = $row['time'];
		$rhometext = filter(stripslashes($row['hometext']), "nohtml");
		$rcomments = intval($row['comments']);
		$rtopic = intval($row['topic']);
		$row2 = $db->sql_fetchrow($db->sql_query("select topictext, topicimage from ".$prefix."_topics where topicid='$rtopic'"));
		$topictext = filter($row2['topictext'], "nohtml");
		$topicimage = filter($row2['topicimage'], "nohtml");
		$content = "%%\n".$rtitle."\n/modules.php?name=News&amp;file=article&amp;sid=".$rsid."\n".$rtime."\n".$raid."\n".$topictext."\n".$rcomments."\n".$topicimage."\n";
		fwrite($file, $content);
	}
	fclose($file);
	$db->sql_freeresult($result);
}

function ultramode2() {
	global $prefix, $db;
	$ultra = "ultramode.txt";
	$file = fopen($ultra, "w");
	fwrite($file, "General purpose self-explanatory file with news headlines\n");
	$sql = "SELECT s.sid, s.catid, s.aid, s.title, s.time, s.hometext, s.comments, s.topic, t.topictext, t.topicimage FROM ".$prefix."_products s LEFT JOIN ".$prefix."_products_topics t ON t.topicid = s.topic WHERE s.ihome = '0' ".$querylang." ORDER BY s.time DESC LIMIT 0,10";
	$result = $db->sql_query($sql);
	while ($row = $db->sql_fetchrow($result)) {
		$rsid = intval($row['sid']);
		$raid = filter($row['aid'], "nohtml");
		$rtitle = filter($row['title'], "nohtml");
		$rtime = $row['time'];
		$rhometext = filter(stripslashes($row['hometext']), "nohtml");
		$rcomments = intval($row['comments']);
		$rtopic = intval($row['topic']);
		$row2 = $db->sql_fetchrow($db->sql_query("select topictext, topicimage from ".$prefix."_topics where topicid='$rtopic'"));
		$topictext = filter($row2['topictext'], "nohtml");
		$topicimage = filter($row2['topicimage'], "nohtml");
		$content = "%%\n".$rtitle."\n/modules.php?name=News&amp;file=article&amp;sid=".$rsid."\n".$rtime."\n".$raid."\n".$topictext."\n".$rcomments."\n".$topicimage."\n";
		fwrite($file, $content);
	}
	fclose($file);
	$db->sql_freeresult($result);
}

function cookiedecode($user) {
    global $cookie, $db, $user_prefix;
    static $pass;
    if(!is_array($user)) {
        $user = base64_decode($user);
        $user = addslashes($user);
        $cookie = explode(":", $user);
    } else {
        $cookie = $user;
    }
    if (!isset($pass) AND isset($cookie[1])) {
       $sql = "SELECT user_password FROM ".$user_prefix."_users WHERE username='$cookie[1]'";
       $result = $db->sql_query($sql);
       list($pass) = $db->sql_fetchrow($result);
       $db->sql_freeresult($result);
    }
    if (isset($cookie[2]) AND ($cookie[2] == $pass) AND (!empty($pass))) { return $cookie; }
}

function getusrinfo($user) {
    global $user_prefix, $db, $userinfo, $cookie;
    if (!$user OR empty($user)) {
      return NULL;
    }
    cookiedecode($user);
    $user = $cookie;
    if (isset($userrow) AND is_array($userrow)) {
        if ($userrow['username'] == $user[1] && $userrow['user_password'] == $user[2]) {
            return $userrow;
        }
    }
    $sql = "SELECT * FROM ".$user_prefix."_users WHERE username='$user[1]' AND user_password='$user[2]'";   // zero
    $result = $db->sql_query($sql);
    if ($db->sql_numrows($result) == 1) {
        static $userrow;
        $userrow = $db->sql_fetchrow($result);
		$result2 = $db->sql_query("SELECT * FROM ".$user_prefix."_cnbya_field");
		while ($sqlvalue = $db->sql_fetchrow($result2)) {
		  list($value) = $db->sql_fetchrow( $db->sql_query("SELECT value FROM ".$user_prefix."_cnbya_value WHERE fid ='$sqlvalue[fid]' AND uid = '$userrow[user_id]'"));
		  $userrow[$sqlvalue['name']] = $value;
		}	
        return $userinfo = $userrow;
    }
    $db->sql_freeresult($result);
    unset($userinfo);
}

function FixQuotes ($what = "") {
	while (stristr($what, "\\\\'")) {
		$what = str_replace("\\\\'","'",$what);
	}
	return $what;
}

/*********************************************************/
/* text filter                                           */
/*********************************************************/

function check_html ($str, $strip="") {
if ($strip == "nohtml") {
        $str = @trim($str);
        if(get_magic_quotes_gpc()) {
            $str = stripslashes($str);
        }
        return htmlentities($str,ENT_QUOTES,"utf-8");
    }else {

        $str = @trim($str);
        if(get_magic_quotes_gpc()) {
            $str = stripslashes($str);
        }
        return mysql_real_escape_string($str);
    }
}

function filter($str , $strip="") {
    if ($strip == "nohtml") {
        $str = @trim($str);
        if(get_magic_quotes_gpc()) {
            $str = stripslashes($str);
        }
        return addslashes($str);
    }else {

        $str = @trim($str);
        if(get_magic_quotes_gpc()) {
            $str = stripslashes($str);
        }
        return mysql_real_escape_string($str);
    }

    }

function wysiwyg_textarea($name, $value, $config = 'NukeUser', $cols = 50, $rows = 10){
    global $nuke_editor , $nukeurl;
    // Don't waste bandwidth by loading WYSIWYG editor for crawlers
    if ($nuke_editor == 0 or !isset($_COOKIE))
    {
        echo "".base64_decode("PHRleHRhcmVhIG5hbWU9IiIgY29scz0iIiByb3dzPSIiPjwvdGV4dGFyZWE+")."";
    } else {
		include_once 'includes/ckeditor/ckeditor.php';
		$ckeditor = new CKEditor();
		$ckeditor->basePath = "$nukeurl"."includes/ckeditor/";
		$ckeditor->config['filebrowserBrowseUrl'] = 'includes/ckfinder/ckfinder.html';
		$ckeditor->config['filebrowserImageBrowseUrl'] = 'includes/ckfinder/ckfinder.html?type=Images';
		$ckeditor->config['filebrowserFlashBrowseUrl'] = 'includes/ckfinder/ckfinder.html?type=Flash';
		$ckeditor->config['filebrowserUploadUrl'] = 'includes/ckfinder/core/connector/php/connector.php?command=QuickUpload&type=Files';
		$ckeditor->config['filebrowserImageUploadUrl'] = 'includes/ckfinder/core/connector/php/connector.php?command=QuickUpload&type=Images';
		$ckeditor->config['filebrowserFlashUploadUrl'] = 'includes/ckfinder/core/connector/php/connector.php?command=QuickUpload&type=Flash';
		if($config == "NukeUser"){
			$ckeditor->config['toolbar'] = array(
				array( 'Source','FitWindow','-' ),
				array( 'Cut','Copy','Paste','PasteText','PasteWord','-','Print' ),
				array( 'Undo','Redo','-','Find','Replace','-','SelectAll','RemoveFormat' ),
				array( 'Link','Unlink','Anchor','StrikeThrough','-','Subscript','Superscript' ),
				array( 'OrderedList','UnorderedList','-','Outdent','Indent' ),
				array( 'JustifyLeft','JustifyCenter','JustifyRight','JustifyFull','Table','Rule','SpecialChar','PageBreak' ),
				array( 'FontName','FontSize','Bold','Italic','Underline','TextColor','BGColor','Smiley' ),
				array( '-','About' )
			);
		}elseif($config == "Basic"){
			$ckeditor->config['toolbar'] = array(
				array( 'FontSize','Bold','Italic','TextColor','-','JustifyLeft','JustifyCenter','JustifyRight','-','Link','Unlink','Smiley','-','About' )
			);

		}elseif($config == "Comments"){
			$ckeditor->config['toolbar'] = array(
				array( 'FontSize','Bold','Italic','TextColor','-','JustifyLeft','JustifyCenter','JustifyRight','-','Link','Smiley','-','About' )
			);
		}elseif($config == "PHPNuke"){
			$ckeditor->config['toolbar'] = array(
				array( 'Source','Image','Bold','Italic','-','JustifyLeft','JustifyCenter','JustifyRight','-','Link','Unlink','-','About' )
			);

		}
		
		$ckeditor->editor($name, $value, $config);
    }
}

function wysiwyg_textarea_html($name, $value, $config = 'NukeUser', $cols = 50, $rows = 10){
    global $nuke_editor;
    // Don't waste bandwidth by loading WYSIWYG editor for crawlers
    if ($nuke_editor == 0 or !isset($_COOKIE))
    {
        echo "".base64_decode("PHRleHRhcmVhIG5hbWU9IiIgY29scz0iIiByb3dzPSIiPjwvdGV4dGFyZWE+")."";
    } else {
		include_once 'includes/ckeditor/ckeditor.php';
		$ckeditor = new CKEditor();
		$ckeditor->basePath = 'includes/ckeditor/';
		$ckeditor->config['filebrowserBrowseUrl'] = 'includes/ckfinder/ckfinder.html';
		$ckeditor->config['filebrowserImageBrowseUrl'] = 'includes/ckfinder/ckfinder.html?type=Images';
		$ckeditor->config['filebrowserFlashBrowseUrl'] = 'includes/ckfinder/ckfinder.html?type=Flash';
		$ckeditor->config['filebrowserUploadUrl'] = 'includes/ckfinder/core/connector/php/connector.php?command=QuickUpload&type=Files';
		$ckeditor->config['filebrowserImageUploadUrl'] = 'includes/ckfinder/core/connector/php/connector.php?command=QuickUpload&type=Images';
		$ckeditor->config['filebrowserFlashUploadUrl'] = 'includes/ckfinder/core/connector/php/connector.php?command=QuickUpload&type=Flash';
		if($config == "NukeUser"){
			$ckeditor->config['toolbar'] = array(
				array( 'Source','FitWindow','-' ),
				array( 'Cut','Copy','Paste','PasteText','PasteWord','-','Print' ),
				array( 'Undo','Redo','-','Find','Replace','-','SelectAll','RemoveFormat' ),
				array( 'Link','Unlink','Anchor','StrikeThrough','-','Subscript','Superscript' ),
				array( 'OrderedList','UnorderedList','-','Outdent','Indent' ),
				array( 'JustifyLeft','JustifyCenter','JustifyRight','JustifyFull','Table','Rule','SpecialChar','PageBreak' ),
				array( 'FontName','FontSize','Bold','Italic','Underline','TextColor','BGColor','Smiley' ),
				array( '-','About' )
			);
		}elseif($config == "Basic"){
			$ckeditor->config['toolbar'] = array(
				array( 'FontSize','Bold','Italic','TextColor','-','JustifyLeft','JustifyCenter','JustifyRight','-','Link','Unlink','Smiley','-','About' )
			);

		}elseif($config == "Comments"){
			$ckeditor->config['toolbar'] = array(
				array( 'FontSize','Bold','Italic','TextColor','-','JustifyLeft','JustifyCenter','JustifyRight','-','Link','Smiley','-','About' )
			);
		}elseif($config == "PHPNuke"){
			$ckeditor->config['toolbar'] = array(
				array( 'Source','Image','Bold','Italic','-','JustifyLeft','JustifyCenter','JustifyRight','-','Link','Unlink','-','About' )
			);

		}
		
		$ckeditor->editor($name, $value, $config);
    }
}


/*********************************************************/
/* formatting stories                                    */
/*********************************************************/

function formatTimestamp($time) {
global $j_month_name,$j_week_name; 	global $datetime, $locale;
    setlocale (LC_TIME, "$locale");
    @ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $time, $datetime);
	$JalaliDate = gregorian_to_jalali($datetime[1],$datetime[2],$datetime[3]);
	$jd = jalali_week_day($JalaliDate[0],$JalaliDate[1],$JalaliDate[2]);
	$datetime = $j_week_name[$jd]
	."، ".$JalaliDate[2]
	." ".$j_month_name[$JalaliDate[1]]
	."، ".$JalaliDate[0];
    return($datetime);
}

function get_author($aid) {
	global $prefix, $db;
    static $users;
    if (isset($users[$aid]) AND is_array($users[$aid])) {
        $row = $users[$aid];
    } else {
        $sql = "SELECT url, email FROM ".$prefix."_authors WHERE aid='$aid'";
        $result = $db->sql_query($sql);
        $row = $db->sql_fetchrow($result);
        $users[$aid] = $row;
        $db->sql_freeresult($result);
    }
	$aidurl = filter($row['url'], "nohtml");
	$aidmail = filter($row['email'], "nohtml");
    if (isset($aidurl) && $aidurl != "http://") {
        $aid = "<a href=\"".$aidurl."\">$aid</a>";
    } elseif (isset($aidmail)) {
        $aid = "<a href=\"mailto:".$aidmail."\">$aid</a>";
    } else {
        $aid = $aid;
    }
    return $aid;
}

function formatAidHeader($aid) {
  $AidHeader = get_author($aid);
  echo $AidHeader;
}

if(defined('ADMIN_FILE')) {
  include_once("admin/template/themes.php");
}

if(!function_exists("themepreview")) {
  function themepreview($title, $hometext, $bodytext="", $notes="") {
    echo "<span class=\"storytitle\">$title</span><br><br>$hometext";
    if (!empty($bodytext)) {
      echo "<br><br>$bodytext";
    }
    if (!empty($notes)) {
      echo "<br><br><b>"._NOTE."</b> <i>$notes</i>";
    }
  }
}

function adminblock() {
	global $admin, $prefix, $db, $admin_file;
	if (is_admin($admin)) {
	    $sql = "SELECT title, content FROM ".$prefix."_blocks WHERE bkey='admin'";
		$result = $db->sql_query($sql);
		while (list($title, $content) = $db->sql_fetchrow($result)) {
			$content = filter($content);
			$title = filter($title, "nohtml");
			$content = "<span class=\"content\">".$content."</span>";
			themesidebox($title, $content, $themeview, $themetype);
		}
		$title = _WAITINGCONT;
		$num = $db->sql_numrows($db->sql_query("SELECT * FROM ".$prefix."_queue"));
		$content = "<span class=\"content\">";
		$content .= "<strong><big>&middot;</big></strong>&nbsp;<a href=\"".$admin_file.".php?op=submissions\">"._SUBMISSIONS."</a>: $num<br>";
		$num = $db->sql_numrows($db->sql_query("SELECT * FROM ".$prefix."_reviews_add"));
		$content .= "<strong><big>&middot;</big></strong>&nbsp;<a href=\"".$admin_file.".php?op=reviews\">"._WREVIEWS."</a>: $num<br>";
		$num = $db->sql_numrows($db->sql_query("SELECT * FROM ".$prefix."_links_newlink"));
		$brokenl = $db->sql_numrows($db->sql_query("SELECT * FROM ".$prefix."_links_modrequest WHERE brokenlink='1'"));
		$modreql = $db->sql_numrows($db->sql_query("SELECT * FROM ".$prefix."_links_modrequest WHERE brokenlink='0'"));
		$content .= "<strong><big>&middot;</big></strong>&nbsp;<a href=\"".$admin_file.".php?op=Links\">"._WLINKS."</a>: $num<br>";
		$content .= "<strong><big>&middot;</big></strong>&nbsp;<a href=\"".$admin_file.".php?op=LinksListModRequests\">"._MODREQLINKS."</a>: $modreql<br>";
		$content .= "<strong><big>&middot;</big></strong>&nbsp;<a href=\"".$admin_file.".php?op=LinksListBrokenLinks\">"._BROKENLINKS."</a>: $brokenl<br>";
		$num = $db->sql_numrows($db->sql_query("SELECT * FROM ".$prefix."_downloads_newdownload"));
		$brokend = $db->sql_numrows($db->sql_query("SELECT * FROM ".$prefix."_downloads_modrequest WHERE brokendownload='1'"));
		$modreqd = $db->sql_numrows($db->sql_query("SELECT * FROM ".$prefix."_downloads_modrequest WHERE brokendownload='0'"));
		$content .= "<strong><big>&middot;</big></strong>&nbsp;<a href=\"".$admin_file.".php?op=downloads\">"._UDOWNLOADS."</a>: $num<br>";
		$content .= "<strong><big>&middot;</big></strong>&nbsp;<a href=\"".$admin_file.".php?op=DownloadsListModRequests\">"._MODREQDOWN."</a>: $modreqd<br>";
		$content .= "<strong><big>&middot;</big></strong>&nbsp;<a href=\"".$admin_file.".php?op=DownloadsListBrokenDownloads\">"._BROKENDOWN."</a>: $brokend<br></span>";
		themesidebox($title, $content, $themeview, $themetype);
	}
}

function loginbox() {
	global $user, $sitekey, $gfx_chk;
	if (!is_user($user)) {
		$title = _LOGIN;
		$boxstuff = "<form action=\"modules.php?name=Your_Account\" method=\"post\">";
		$boxstuff .= "<center><font class=\"content\">"._NICKNAME."<br>";
		$boxstuff .= "<input type=\"text\" name=\"username\" size=\"8\" maxlength=\"25\"><br>";
		$boxstuff .= ""._PASSWORD."<br>";
		$boxstuff .= "<input type=\"password\" name=\"user_password\" size=\"8\" maxlength=\"20\"><br>";
		if (extension_loaded("gd") AND ($gfx_chk == 2 OR $gfx_chk == 4 OR $gfx_chk == 5 OR $gfx_chk == 7)) {
			$boxstuff .= "".makePass("qregg")."";
		}
		$boxstuff .= "<input type=\"hidden\" name=\"op\" value=\"login\">";
		$boxstuff .= "<input type=\"submit\" value=\""._LOGIN."\"></font></center></form>";
		$boxstuff .= "<center><font class=\"content\">"._ASREGISTERED."</font></center>";
		themesidebox($title, $boxstuff, $themeview, $themetype);
	}
}

function userblock() {
  global $user, $cookie, $db, $user_prefix, $userinfo;
  if(is_user($user)) {
    getusrinfo($user);
    if($userinfo['ublockon']) {
      $sql = "SELECT ublock FROM ".$user_prefix."_users WHERE user_id='$cookie[0]'";
      $result = $db->sql_query($sql);
      $row = $db->sql_fetchrow($result);
      $ublock = intval($row['ublock']);
      $title = _MENUFOR." ".$cookie[1];
      themesidebox($title, $ublock, $themeview, $themetype);
    }
  }
}

function getTopics($sid) {
	global $topicid, $topicname, $topicimage, $topictext, $prefix, $db;
	$sid = intval($s_sid);
	$result = $db->sql_query("SELECT t.topicid, t.topicname, t.topicimage, t.topictext FROM ".$prefix."_stories s LEFT JOIN ".$prefix."_topics t ON t.topicid = s.topic WHERE s.sid = ".$sid);
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);
	$topicid = intval($row['topicid']);
	$topicname = filter($row['topicname'], "nohtml");
	$topicimage = filter($row['topicimage'], "nohtml");
	$topictext = filter($row['topictext'], "nohtml");
}

function getTopics2($sid) {
	global $topicid, $topicname, $topicimage, $topictext, $prefix, $db;
	$sid = intval($s_sid);
	$result = $db->sql_query("SELECT t.topicid, t.topicname, t.topicimage, t.topictext FROM ".$prefix."_products s LEFT JOIN ".$prefix."_products_topics t ON t.topicid = s.topic WHERE s.sid = ".$sid);
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);
	$topicid = intval($row['topicid']);
	$topicname = filter($row['topicname'], "nohtml");
	$topicimage = filter($row['topicimage'], "nohtml");
	$topictext = filter($row['topictext'], "nohtml");
}

function headlines($bid, $cenbox=0, $themetype) {
	global $prefix, $db;
	$bid = intval($bid);
	$result = $db->sql_query("SELECT title, content, url, refresh, time FROM ".$prefix."_blocks WHERE bid='$bid'");
	$row = $db->sql_fetchrow($result);
	$title = filter($row['title'], "nohtml");
	$content = filter($row['content']);
	$url = filter($row['url'], "nohtml");
	$refresh = intval($row['refresh']);
	$themetype = intval($row['blocks_sides']);
	$otime = $row['time'];
	$past = time()-$refresh;
	$cont = 0;
	if ($otime < $past) {
		$btime = time();
		$rdf = parse_url($url);
		$fp = fsockopen($rdf['host'], 80, $errno, $errstr, 15);
		if (!$fp) {
			$content = "";
			$db->sql_query("UPDATE ".$prefix."_blocks SET content='$content', time='$btime' WHERE bid='$bid'");
			$cont = 0;
			if ($cenbox == 0) {
				themesidebox($title, $content, $themeview, $themetype);
			} else {
				themecenterbox($title, $content, $themeview, $themetype);
			}
			return;
		}
		if ($fp) {
			if (!empty($rdf['query']))
			$rdf['query'] = "?" . $rdf['query'];

			fputs($fp, "GET " . $rdf['path'] . $rdf['query'] . " HTTP/1.0\r\n");
			fputs($fp, "HOST: " . $rdf['host'] . "\r\n\r\n");
			$string	= "";
			while(!feof($fp)) {
				$pagetext = fgets($fp,300);
				$string .= chop($pagetext);
			}
			fputs($fp,"Connection: close\r\n\r\n");
			fclose($fp);
			$items = explode("</item>",$string);
			$content = "<font class=\"content\">";
			for ($i=0;$i<10;$i++) {
				$link = @ereg_replace(".*<link>","",$items[$i]);
				$link = @ereg_replace("</link>.*","",$link);
				$title2 = @ereg_replace(".*<title>","",$items[$i]);
				$title2 = @ereg_replace("</title>.*","",$title2);
				$title2 = stripslashes($title2);
				if (empty($items[$i]) AND $cont != 1) {
					$content = "";
					$db->sql_query("UPDATE ".$prefix."_blocks SET content='$content', time='$btime' WHERE bid='$bid'");
					$cont = 0;
					if ($cenbox == 0) {
						themesidebox($title, $content, $themeview, $themetype);
					} else {
						themecenterbox($title, $content, $themeview=1, $themetype);
					}
					return;
				} else {
					if (strcmp($link,$title2) AND !empty($items[$i])) {
						$cont = 1;
						$content .= "<strong><big>&middot;</big></strong><a href=\"$link\" target=\"new\">$title2</a><br>\n";
					}
				}
			}

		}
		$db->sql_query("UPDATE ".$prefix."_blocks SET content='$content', time='$btime' WHERE bid='$bid'");
	}
	$siteurl = str_replace("http://","",$url);
	$siteurl = explode("/",$siteurl);
	if (($cont == 1) OR (!empty($content))) {
		$content .= "<br><a href=\"http://$siteurl[0]\" target=\"blank\"><b>"._HREADMORE."</b></a></font>";
	} elseif (($cont == 0) OR (empty($content))) {
		$content = "<font class=\"content\">"._RSSPROBLEM."</font>";
	}
	if ($cenbox == 0) {
		themesidebox($title, $content, $themeview, $themetype);
	} else {
		themecenterbox($title, $content, $themeview=1, $themetype);
	}
}

function automated_news() {
	global $prefix, $multilingual, $currentlang, $db, $adminmail;
	if ($multilingual == 1) {
		$querylang = "WHERE (alanguage='$currentlang' OR alanguage='')";
	} else {
		$querylang = "";
	}
	$result = $db->sql_query("SELECT * FROM ".$prefix."_autonews $querylang");
	while ($row = $db->sql_fetchrow($result)) {
		$anid = intval($row['anid']);
		$time = $row['time'];
		if($time <= time()){
			$title = $row['title'];
			$hometext = stripslashes($row['hometext']);
			$bodytext = stripslashes($row['bodytext']);
			$newslevel2 = ($row['newslevel']);
			$news_group2 = intval($row['news_group']);
			$notes = filter($row['notes'], "", 1);
			$aid2 = filter($row['aid'], "nohtml", 1);
			$topic2 = $row['topic'];
			$informant2 = filter($row['informant'], "nohtml", 1);
			$ihome2 = intval($row['ihome']);
			$alanguage2 = $row['alanguage'];
			$acomm2 = intval($row['acomm']);
			$associated2 = $row['associated'];
			$position2 = $row['position'];
			$story_pass2 = $row['story_pass'];
			$topic_link2 = $row['topic_link'];
			$newsurl2 = addslashes($row['newsurl']);
			$conresult = $db->sql_query("insert into ".$prefix."_stories
	(aid,title,time,hometext,bodytext,newslevel,news_group,newsurl,comments,counter,topic,informant,notes,ihome,alanguage,acomm,haspoll,pollID,score,ratings,rating_ip,position,story_pass,topic_link) values ('$aid2', '$title', '$time', '$hometext', '$bodytext', '$newslevel2', '$news_group2', '$newsurl2', '0', '0', '$topic2', '$informant2', '$notes', '$ihome2', '$alanguage2', '$acomm2', '0', '0', '0', '0', '0', '$position2', '$story_pass2', '$topic_link2')");
			if($conresult){
				$db->sql_query("DELETE FROM ".$prefix."_autonews WHERE anid='$anid'");
				$newresult = $db->sql_query("SELECT sid FROM ".$prefix."_stories ORDER BY time DESC LIMIT 0,1");
				$newrow = $db->sql_fetchrow($newresult);
				$sid = $newrow['sid'];
				rename("files/auto/$anid.jpg","files/News/$sid.jpg");
				rename("files/auto/tumbs/$anid.jpg","files/News/thumbs/$sid.jpg");
			}
		}
		
	}
	$db->sql_freeresult($result);
}

if(!defined('FORUM_ADMIN') && !defined('ADMIN_FILE')) {
  $ThemeSel = get_theme();
  include_once("themes/$ThemeSel/theme.php");
}

if(!function_exists("themecenterbox")) {
function themecenterbox($title, $content, $themeview=1, $themetype) {
	OpenTable();
	echo "<center><font class=\"option\"><b>$title</b></font></center><br>".$content;
	CloseTable();
	echo "<br>";
  }
}

function public_message() {
	global $prefix, $user_prefix, $db, $user, $admin, $p_msg, $cookie, $broadcast_msg;
	if ($broadcast_msg == 1) {
		if (is_user($user)) {
			cookiedecode($user);
			$result = $db->sql_query("SELECT broadcast FROM ".$user_prefix."_users WHERE username='$cookie[1]'");
			$row = $db->sql_fetchrow($result);
			$upref = intval($row['broadcast']);
			if ($upref == 1) {
				$t_off = "<br><p align=\"right\">[ <a href=\"modules.php?name=Your_Account&amp;op=edithome\">";
				$t_off .= "<font size=\"2\">"._TURNOFFMSG."</font></a> ]";
				$pm_show = 1;
			} else {
				$pm_show = 0;
			}
		} else {
			$t_off = "";
		}
		if (!is_user($user) OR (is_user($user) AND ($pm_show == 1))) {
			$c_mid = base64_decode($p_msg);
			$c_mid = addslashes($c_mid);
			$c_mid = intval($c_mid);
			$result2 = $db->sql_query("SELECT mid, content, date, who FROM ".$prefix."_public_messages WHERE mid > '$c_mid' ORDER BY date ASC LIMIT 1");
			$row2 = $db->sql_fetchrow($result2);
			$mid = intval($row2['mid']);
			$content = filter($row2['content'], "nohtml");
			$tdate = $row2['date'];
			$who = filter($row2['who'], "nohtml");
			if ((!isset($c_mid)) OR ($c_mid = $mid)) {
				$public_msg = "<br><table width=\"90%\" border=\"1\" cellspacing=\"2\" cellpadding=\"0\" bgcolor=\"FFFFFF\" align=\"center\"><tr><td>\n";
				$public_msg .= "<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"2\" bgcolor=\"FF0000\"><tr><td>\n";
				$public_msg .= "<font color=\"FFFFFF\" size=\"3\"><b>"._BROADCASTFROM." <a href=\"modules.php?name=Your_Account&amp;op=userinfo&amp;username=$who\"><font color=\"FFFFFF\" size=\"3\">$who</font></a>: \"$content\"</b>";
				$public_msg .= "$t_off";
				$public_msg .= "</td></tr></table>";
				$public_msg .= "</td></tr></table>";
				$ref_date = $tdate+600;
				$actual_date = time();
				if ($actual_date >= $ref_date) {
					$public_msg = "";
					$numrows = $db->sql_numrows($db->sql_query("SELECT * FROM ".$prefix."_public_messages"));
					if ($numrows == 1) {
						$db->sql_query("DELETE FROM ".$prefix."_public_messages");
						$mid = 0;
					} else {
						$db->sql_query("DELETE FROM ".$prefix."_public_messages WHERE mid='$mid'");
					}
				}
				if ($mid == 0 OR empty($mid)) {
					nuke_set_cookie("p_msg",false,'');
				} else {
					$mid = base64_encode($mid);
					$mid = addslashes($mid);
					nuke_set_cookie("p_msg",$mid,time()+600);
				}
			}
		}
	} else {
		$public_msg = "";
	}
	if (empty($public_msg)) { $public_msg = ""; }
	return $public_msg;
}

function get_theme() {
    global $user, $userinfo, $Default_Theme, $name, $op, $align;
    if (isset($ThemeSelSave)) return $ThemeSelSave;
    if (is_user($user) && ($name != "Your_Account" OR $op != "logout")) {
        getusrinfo($user);
        if(empty($userinfo['theme'])) $userinfo['theme']=$Default_Theme;
        if(file_exists("themes/".$userinfo['theme']."/theme.php")) {
            $ThemeSel = "".$userinfo['theme']."";
        } else {
            $ThemeSel = "$Default_Theme";
        }
    } else {
        $ThemeSel = "$Default_Theme";
    }
    static $ThemeSelSave;
    $ThemeSelSave = $ThemeSel;
    return $ThemeSelSave;
}

function removecrlf($str) {
	return strtr($str, "\015\012", ' ');
}

function validate_mail($email) {
  if(strlen($email) < 7 || !@eregi("^[_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,6}$",$email)) {
     OpenTable();
     echo _ERRORINVEMAIL;
     CloseTable();
     die();
     } else {
     return $email;
     }
}

function paid() {
	global $db, $user, $cookie, $adminmail, $sitename, $nukeurl, $subscription_url, $user_prefix, $prefix;
	if (is_user($user)) {
		if (!empty($subscription_url)) {
			$renew = ""._SUBRENEW." $subscription_url";
		} else {
			$renew = "";
		}
		cookiedecode($user);
		$sql = "SELECT * FROM ".$prefix."_subscriptions WHERE userid='$cookie[0]'";
		$result = $db->sql_query($sql);
		$numrows = $db->sql_numrows($result);
		$row = $db->sql_fetchrow($result);
		if ($numrows == 0) {
			return 0;
		} elseif ($numrows != 0) {
			$time = time();
			if ($row['subscription_expire'] <= $time) {
				$db->sql_query("DELETE FROM ".$prefix."_subscriptions WHERE userid='$cookie[0]' AND id='".intval($row['id'])."'");
				$subject = "$sitename: "._SUBEXPIRED."";
				$body = ""._HELLO." $cookie[1]:\n\n"._SUBSCRIPTIONAT." $sitename "._HASEXPIRED."\n$renew\n\n"._HOPESERVED."\n\n$sitename "._TEAM."\n$nukeurl";
				$row = $db->sql_fetchrow($db->sql_query("SELECT user_email FROM ".$user_prefix."_users WHERE id='$cookie[0]' AND nickname='$cookie[1]' AND password='$cookie[2]'"));
				phpnuke_mail($row['user_email'],$subject,$body,$adminmail,$sitename);
			}
			return 1;
		}
	} else {
		return 0;
	}
}

function ads($position) {
	global $prefix, $db, $admin, $sitename, $adminmail, $nukeurl;
	$position = intval($position);
	if (paid()) {
		return;
	}
	$numrows = $db->sql_numrows($db->sql_query("SELECT * FROM ".$prefix."_banner WHERE position='$position' AND active='1'"));
	/* Get a random banner if exist any. */
	if ($numrows > 1) {
		$numrows = $numrows-1;
		mt_srand((double)microtime()*1000000);
		$bannum = mt_rand(0, $numrows);
	} else {
		$bannum = 0;
	}
	$sql = "SELECT bid, impmade, imageurl, clickurl, alttext FROM ".$prefix."_banner WHERE position='$position' AND active='1' LIMIT $bannum,1";
	$result = $db->sql_query($sql);
	list($bid, $impmade, $imageurl, $clickurl, $alttext) = $db->sql_fetchrow($result);
	$bid = intval($bid);
	$imageurl = filter($imageurl, "nohtml");
	$clickurl = filter($clickurl, "nohtml");
	$alttext = filter($alttext, "nohtml");
	$db->sql_query("UPDATE ".$prefix."_banner SET impmade=impmade+1 WHERE bid='$bid'");
	if($numrows > 0) {
		$sql2 = "SELECT cid, imptotal, impmade, clicks, date, ad_class, ad_code, ad_width, ad_height FROM ".$prefix."_banner WHERE bid='$bid'";
		$result2 = $db->sql_query($sql2);
		list($cid, $imptotal, $impmade, $clicks, $date, $ad_class, $ad_code, $ad_width, $ad_height) = $db->sql_fetchrow($result2);
		$cid = intval($cid);
		$imptotal = intval($imptotal);
		$impmade = intval($impmade);
		$clicks = intval($clicks);
		$ad_class = filter($ad_class, "nohtml");
		$ad_width = intval($ad_width);
		$ad_height = intval($ad_height);
		/* Check if this impression is the last one and print the banner */
		if (($imptotal <= $impmade) AND ($imptotal != 0)) {
			$db->sql_query("UPDATE ".$prefix."_banner SET active='0' WHERE bid='$bid'");
			$sql3 = "SELECT name, contact, email FROM ".$prefix."_banner_clients WHERE cid='$cid'";
			$result3 = $db->sql_query($sql3);
			list($c_name, $c_contact, $c_email) = $db->sql_fetchrow($result3);
			$c_name = filter($c_name, "nohtml");
			$c_contact = filter($c_contact, "nohtml");
			$c_email = filter($c_email, "nohtml");
			if (!empty($c_email)) {
				$from = "$sitename <$adminmail>";
				$to = "$c_contact <$c_email>";
				$message = _HELLO." $c_contact:\n\n";
				$message .= _THISISAUTOMATED."\n\n";
				$message .= _THERESULTS."\n\n";
				$message .= _TOTALIMPRESSIONS." $imptotal\n";
				$message .= _CLICKSRECEIVED." $clicks\n";
				$message .= _IMAGEURL." $imageurl\n";
				$message .= _CLICKURL." $clickurl\n";
				$message .= _ALTERNATETEXT." $alttext\n\n";
				$message .= _HOPEYOULIKED."\n\n";
				$message .= _THANKSUPPORT."\n\n";
				$message .= "- $sitename "._TEAM."\n";
				$message .= "$nukeurl";
				$subject = "$sitename: "._BANNERSFINNISHED."";
				phpnuke_mail($to,$subject,$message,$adminmail,$sitename);
			}
		}
		if ($ad_class == "code") {
			$ad_code = stripslashes(FixQuotes($ad_code));
			$ads = "<center>$ad_code</center>";
		} elseif ($ad_class == "flash") {
			$ads = "<center>
				<OBJECT classid=\"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000\"
				codebase=\"http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,40,0\"
				WIDTH=\"$ad_width\" HEIGHT=\"$ad_height\" id=\"$bid\">
				<PARAM NAME=movie VALUE=\"$imageurl\">
				<PARAM NAME=quality VALUE=high>
				<EMBED src=\"$imageurl\" quality=high WIDTH=\"$ad_width\" HEIGHT=\"$ad_height\"
				NAME=\"$bid\" ALIGN=\"\" TYPE=\"application/x-shockwave-flash\"
				PLUGINSPAGE=\"http://www.macromedia.com/go/getflashplayer\">
				</EMBED>
				</OBJECT>
				</center>";
		} else {
			$ads = "<center><a href=\"index.php?op=ad_click&amp;bid=$bid\" target=\"_blank\"><img src=\"$imageurl\" border=\"0\" alt=\"$alttext\" title=\"$alttext\"></a></center>";
		}
	} else {
		$ads = "";	
	}
	return $ads;
}

function redir($content) {
	global $nukeurl;
	unset($location);
	$content = filter($content);
	$links = array();
	$hrefs = array();
	$pos = 0;
	while (!(($pos = strpos($content,"<",$pos)) === false)) {
		$pos++;
		$endpos = strpos($content,">",$pos);
		$tag = substr($content,$pos,$endpos-$pos);
		$tag = trim($tag);
		if (isset($location)) {
			if (!strcasecmp(strtok($tag," "),"/A")) {
				$link = substr($content,$linkpos,$pos-1-$linkpos);
				$links[] = $link;
				$hrefs[] = $location;
				unset($location);
			}
			$pos = $endpos+1;
		} else {
			if (!strcasecmp(strtok($tag," "),"A")) {
				if (@eregi("HREF[ \t\n\r\v]*=[ \t\n\r\v]*\"([^\"]*)\"",$tag,$regs));
				else if (@eregi("HREF[ \t\n\r\v]*=[ \t\n\r\v]*([^ \t\n\r\v]*)",$tag,$regs));
				else $regs[1] = "";
				if ($regs[1]) {
					$location = $regs[1];
				}
				$pos = $endpos+1;
				$linkpos = $pos;
			} else {
				$pos = $endpos+1;
			}
		}
	}
	for ($i=0; $i<sizeof($hrefs); $i++) {
		$url = urlencode($hrefs[$i]);
		$content = str_replace("<a href=\"$hrefs[$i]\">", "<a href=\"$nukeurl/index.php?url=$url\" target=\"_blank\">", $content);
	}
	return($content);
}

function info_box($graphic, $message) {
	// Function to generate a message box with a graphic inside
	// $graphic value can be whichever: warning, caution, tip, note.
	// Then the graphic value with the extension .gif should be present inside /images/system/ folder
	if (file_exists("images/system/".$graphic.".gif") AND !empty($message)) {
		Opentable();
		$graphic = filter($graphic, "nohtml");
		$message = filter($message, "");
		echo "<table align=\"center\" border=\"0\" width=\"80%\" cellpadding=\"10\"><tr>"
			."<td valign=\"top\"><img src=\"images/system/".$graphic.".gif\" border=\"0\" alt=\"\" title=\"\" width=\"34\" height=\"34\"></td>"
			."<td valign=\"top\">$message</td>"
			."</tr></table>";
		CloseTable();
	} else {
		return;
	}
}

if (isset($gfx)){
switch($gfx) {

	case "gfx":
	$datekey = date("F j");
	$rcode = hexdec(md5($_SERVER['HTTP_USER_AGENT'] . $sitekey . $random_num . $datekey));
	$code = substr($rcode, 2, 6);
	$ThemeSel = get_theme();
	if (file_exists("themes/".$ThemeSel."/images/code_bg.jpg")) {
		$image = ImageCreateFromJPEG("themes/".$ThemeSel."/images/code_bg.jpg");
	} else {
		$image = ImageCreateFromJPEG("images/code_bg.jpg");
	}
	$text_color = ImageColorAllocate($image, 80, 80, 80);
	Header("Content-type: image/jpeg");
	ImageString ($image, 5, 12, 2, $code, $text_color);
	ImageJPEG($image, NULL, 75);
	ImageDestroy($image);
	die();
	break;

	case "gfx_little":
	$datekey = date("F j");
	$rcode = hexdec(md5($_SERVER['HTTP_USER_AGENT'] . $sitekey . $random_num . $datekey));
	$code = substr($rcode, 2, 3);
	$ThemeSel = get_theme();
	if (file_exists("themes/".$ThemeSel."/images/code_bg_little.jpg")) {
		$image = ImageCreateFromJPEG("themes/".$ThemeSel."/images/code_bg_little.jpg");
	} else {
		$image = ImageCreateFromJPEG("images/code_bg_little.jpg");
	}
	$text_color = ImageColorAllocate($image, 80, 80, 80);
	Header("Content-type: image/jpeg");
	ImageString ($image, 5, 12, 2, $code, $text_color);
	ImageJPEG($image, NULL, 75);
	ImageDestroy($image);
	die();
	break;
   }
}
function div($a, $b){
   return (int) ($a / $b);
}

function isnum($str){
    if (strlen($str) == 0)
	return 0;
    for ($i = 0; $i < strlen($str); $i++)
        if (ord($str[$i]) < ord("0") || ord($str[$i]) > ord("9"))
            return 0;
    return 1;
}

function hex2int($str){
    $str = strtoupper($str);
    for ($i = 0, $n = 0; $i < strlen($str); $i++)
    {
	$n *= 0x10;
        if (ord($str[$i]) < ord("0") || ord($str[$i]) > ord("9"))
            $n += 10 + ord($str[$i]) - ord("A");
	else
            $n += ord($str[$i]) - ord("0");
    }
    return $n;
}

//Part2
$g_days_in_month = array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
$j_days_in_month = array(31, 31, 31, 31, 31, 31, 30, 30, 30, 30, 30, 29);

function gregorian_to_jalali($g_y, $g_m, $g_d){
   global $g_days_in_month;
   global $j_days_in_month;

   $gy = $g_y-1600;
   $gm = $g_m-1;
   $gd = $g_d-1;

   $g_day_no = 365*$gy+div($gy+3,4)-div($gy+99,100)+div($gy+399,400);

   for ($i=0; $i < $gm; ++$i)
      $g_day_no += $g_days_in_month[$i];
   if ($gm>1 && (($gy%4==0 && $gy%100!=0) || ($gy%400==0)))
      /* leap and after Feb */
      $g_day_no++;
   $g_day_no += $gd;

   $j_day_no = $g_day_no-79;

   $j_np = div($j_day_no, 12053); /* 12053 = 365*33 + 32/4 */
   $j_day_no = $j_day_no % 12053;

   $jy = 979+33*$j_np+4*div($j_day_no,1461); /* 1461 = 365*4 + 4/4 */

   $j_day_no %= 1461;

   if ($j_day_no >= 366) {
      $jy += div($j_day_no-1, 365);
      $j_day_no = ($j_day_no-1)%365;
   }

   for ($i = 0; $i < 11 && $j_day_no >= $j_days_in_month[$i]; ++$i)
      $j_day_no -= $j_days_in_month[$i];
   $jm = $i+1;
   $jd = $j_day_no+1;

   return array($jy, $jm, $jd);
}

function gregorian_week_day($g_y, $g_m, $g_d){
   global $g_days_in_month;

   $gy = $g_y-1600;
   $gm = $g_m-1;
   $gd = $g_d-1;

   $g_day_no = 365*$gy+div($gy+3,4)-div($gy+99,100)+div($gy+399,400);

   for ($i=0; $i < $gm; ++$i)
      $g_day_no += $g_days_in_month[$i];
   if ($gm>1 && (($gy%4==0 && $gy%100!=0) || ($gy%400==0)))
      /* leap and after Feb */
      ++$g_day_no;
   $g_day_no += $gd;

   return ($g_day_no + 5) % 7 + 1;
}

function jalali_to_gregorian($j_y, $j_m, $j_d){
   global $g_days_in_month;
   global $j_days_in_month;

   $jy = $j_y-979;
   $jm = $j_m-1;
   $jd = $j_d-1;

   $j_day_no = 365*$jy + div($jy, 33)*8 + div($jy%33+3, 4);
   for ($i=0; $i < $jm; ++$i)
      $j_day_no += $j_days_in_month[$i];

   $j_day_no += $jd;

   $g_day_no = $j_day_no+79;

   $gy = 1600 + 400*div($g_day_no, 146097); /* 146097 = 365*400 + 400/4 - 400/100 + 400/400 */
   $g_day_no = $g_day_no % 146097;

   $leap = true;
   if ($g_day_no >= 36525) /* 36525 = 365*100 + 100/4 */
   {
      $g_day_no--;
      $gy += 100*div($g_day_no,  36524); /* 36524 = 365*100 + 100/4 - 100/100 */
      $g_day_no = $g_day_no % 36524;

      if ($g_day_no >= 365)
         $g_day_no++;
      else
         $leap = false;
   }

   $gy += 4*div($g_day_no, 1461); /* 1461 = 365*4 + 4/4 */
   $g_day_no %= 1461;

   if ($g_day_no >= 366) {
      $leap = false;

      $g_day_no--;
      $gy += div($g_day_no, 365);
      $g_day_no = $g_day_no % 365;
   }

   for ($i = 0; $g_day_no >= $g_days_in_month[$i] + ($i == 1 && $leap); $i++)
      $g_day_no -= $g_days_in_month[$i] + ($i == 1 && $leap);
   $gm = $i+1;
   $gd = $g_day_no+1;

   return array($gy, $gm, $gd);
}

function jalali_week_day($j_y, $j_m, $j_d){
   global $j_days_in_month;

   $jy = $j_y-979;
   $jm = $j_m-1;
   $jd = $j_d-1;

   $j_day_no = 365*$jy + div($jy, 33)*8 + div($jy%33+3, 4);

   for ($i=0; $i < $jm; ++$i)
      $j_day_no += $j_days_in_month[$i];

   $j_day_no += $jd;

   return ($j_day_no + 2) % 7 + 1;
}

function jcheckdate($j_m, $j_d, $j_y){
   global $j_days_in_month;

   if ($j_y < 0 || $j_y > 32767 || $j_m < 1 || $j_m > 12 || $j_d < 1 || $j_d >
           ($j_days_in_month[$j_m-1] + ($j_m == 12 && !(($j_y-979)%33%4))))
       return false;
   return true;
}

//FARSINUKE FUNCTIONS!
function FarsiMail($message){
	$tmpmsg = $message;
	$message = "<html><head>";
	$message .= "<meta http-equiv=\"Content-Language\" content=\"fa\">";
	$message .= "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">";
	$message .= "</head><body>";
	$message .= "<table dir=\"rtl\"border=\"0\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#111111\" width=\"100%\"><tr><td width=\"100%\" valign=\"top\">";
	$message .= "<font face=\"Tahoma\" size=\"2\">";
	$message .= $tmpmsg;
	$message .= "</font></td></tr>";
	$message .= "</body></html>";
return $message;
}

function FarsiMailNewsletter($message){
	$tmpmsg = $message;
	$message = "<html><head>";
	$message .= "<meta http-equiv=\"Content-Language\" content=\"fa\">";
	$message .= "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">";
	$message .= "</head><body>";
	$message .= "<table dir=\"rtl\"border=\"0\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#111111\" width=\"100%\"><tr><td width=\"100%\" valign=\"top\">";
	$message .= "<font face=\"Tahoma\" size=\"2\">";
	$message .= $tmpmsg;
	$message .= "</font></td></tr>";
	$message .= "</body></html>";
return $message;
}

function phpnuke_mail($to,$subject,$message,$from, $from_desc){
	global $nukeurl,$sitename, $textalign1, $adminmail;
	if($from == ""){
		$from = $adminmail;
	}
	if($from_desc == ""){
		$from_desc = $sitename;
	}
	if(file_exists("images/logo.gif")){
		$logoimage = "<img alt='' id='logo' src='images/logo.gif' width='108' height='69' />";
	}elseif(file_exists("images/logo.png")){
		$logoimage = "<img alt='$sitename' src='images/logo.png' width='108' height='69' />";
	}elseif(file_exists("images/logo.jpg")){
		$logoimage = "<img alt='$sitename' src='images/logo.jpg' width='108' height='69' />";
	}
	$headers  = 'MIME-Version: 1.0' . "\r\n";
	$headers .= 'Content-type: text/html; charset=utf-8' . "\r\n";
	$headers .= 'From: '.$from_desc.' <'.$from.'>' . "\r\n";
	if(function_exists('mail_theme')){
		$message = mail_theme($subject, $logoimage, $message);
	}else{
		$message = "
		<html>\n
			<head>\n
				<meta http-equiv='content-type' content='text/html; charset=utf-8'>\n
				<base target=_blank>\n
			</head>\n
			<body>\n
			<span dir='rtl'>\n
				<div>\n
					<table width='700px' bgcolor='#F4EAFF' style='border: 1px solid #310062;font-family: tahoma;font-size:12px;' align='center' dir='rtl' cellspacing='4' cellpadding='4'>\n
						<tr >\n
							<td width='150'>&nbsp;</td>\n
							<td style='font-weight: bold' align='center' width='400' height='100'>$subject</td>\n
							<td align='left' width='150'>$logoimage</td>\n
						</tr>\n
						<tr>\n
							<td colspan='3' align='$textalign1'>\n
								$message
							</td>\n
						</tr>\n
					</table>\n
				</div>\n
			</span>\n
		</body>\n
		</html>\n";
	}
	mail($to,$subject,$message,$headers);
}


/*With the functions provided below you can easily convert gregorian date to hejri date

Hejri Functions*/

function FormalDate2Hejri($time){
	@ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})", $time, $datetime);
	$JalaliDate = gregorian_to_jalali($datetime[1],$datetime[2],$datetime[3]);
	$datetime = $JalaliDate[2]."-".$JalaliDate[1]."-".$JalaliDate[0];
return $datetime;
}

function FormalDate2Hejri1($time){
	global $j_month_name;
	@ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})", $time, $datetime);
	$JalaliDate = gregorian_to_jalali($datetime[1],$datetime[2],$datetime[3]);
	$datetime = $JalaliDate[2]." ".$j_month_name[$JalaliDate[1]]."، ".$JalaliDate[0];
return $datetime;
}

function FormalDate2Hejri2($time){
	@ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $time, $datetime);
	$JalaliDate = gregorian_to_jalali($datetime[1],$datetime[2],$datetime[3]);
	$datetime = $JalaliDate[2]."-".$JalaliDate[1]."-".$JalaliDate[0]." ".$datetime[4].":".$datetime[5].":".$datetime[6];
return $datetime;
}

function FormalDate2Hejri3($time){
	global $j_month_name,$j_week_name;
    @ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $time, $datetime);
	$JalaliDate = gregorian_to_jalali($datetime[1],$datetime[2],$datetime[3]);
	$jd = jalali_week_day($JalaliDate[0],$JalaliDate[1],$JalaliDate[2]);
	$datetime = $j_week_name[$jd]
	."، ".$JalaliDate[2]
	." ".$j_month_name[$JalaliDate[1]];
    return($datetime);
}

function FormalDate2Hejri4($time){
	@ereg ("([0-9]{1,2})-([0-9]{1,2})-([0-9]{4})", $time, $datetime);
	$JalaliDate = gregorian_to_jalali($datetime[3],$datetime[2],$datetime[1]);
	$datetime = $JalaliDate[2]."-".$JalaliDate[1]."-".$JalaliDate[0];
return $datetime;
}

function FormalDate2Hejri5($time){
	global $j_month_name,$j_week_name;
    @ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $time, $datetime);
	$JalaliDate = gregorian_to_jalali($datetime[1],$datetime[2],$datetime[3]);
	$datetime = $JalaliDate[2]." ".$j_month_name[$JalaliDate[1]]."، ".$JalaliDate[0]
	." @ ".$datetime[4].":".$datetime[5].":".$datetime[6];
return $datetime;
}

function FormalDate2Hejri6($time){
	global $j_month_name,$j_week_name;
    @ereg ("([A-z]{3}), ([0-9]{1,2}) ([0-9]{1,2}) ([A-z]{1,2})", $time, $datetime);
	$JalaliDate = gregorian_to_jalali($datetime[1],$datetime[2],$datetime[3]);
	$datetime = $JalaliDate[2]." ".$j_month_name[$JalaliDate[1]]."، ".$JalaliDate[0]
	." @ ".$datetime[4].":".$datetime[5].":".$datetime[6];
return $datetime;
}

function back2formaldate($time){
    @ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $time, $datetime);
	$gdate = jalali_to_gregorian($datetime[1],$datetime[2],$datetime[3]);
	$time = $gdate[0]."-".$gdate[1]."-".$gdate[2]." ".$datetime[4].":".$datetime[5].":".$datetime[6];
return $time;
}

function now_in_hejri($now){
	$now = getdate();
	$now = $now['year']."-".$now['mon']."-".$now['mday']." ".$now['hours'].":".$now['minutes'].":".$now['seconds'];
	$now = formatTimestamp($now);
return $now;
}

function echo_now(){
	$now = now_in_hejri($now);
	echo $now;
}

function forum_date($time){
	global $j_month_name,$j_week_name;
    @ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $time, $datetime);
	$JalaliDate = gregorian_to_jalali($datetime[1],$datetime[2],$datetime[3]);
	$jd = jalali_week_day($JalaliDate[0],$JalaliDate[1],$JalaliDate[2]);
	$datetime = $j_week_name[$jd]
	."، ".$JalaliDate[2]
	." ".$j_month_name[$JalaliDate[1]]
	."، ".$JalaliDate[0]
	." ".$datetime[4].":".$datetime[5].":".$datetime[6];
return($datetime);
}

function is_kabise($year){
	if(($year%33==1) OR($year%33==5) OR($year%33==9) OR($year%33==13) OR($year%33==17) OR($year%33==22) OR($year%33==26) OR($year%33==30))
		return true;
	return false;
}

//**********************Gregorian date to hehri date
class HijriCalendar{
   function monthName($i) // $i = 1..12
   {
   global $A_month_name;
       return $A_month_name[$i-1];
   }
   function GregorianToHijri($time = null)
   {
       if ($time === null) $time = time();
       $m = date('m', $time);
       $d = date('d', $time);
       $y = date('Y', $time);
       return $this->JDToHijri(
           cal_to_jd(CAL_GREGORIAN, $m, $d, $y));
   }
   function HijriToGregorian($y, $m, $d)
   {
       return jd_to_cal(HjriCalendar::HijriToJD($y, $m, $d));
   }
   # Julian Day Count To Hijri
   function JDToHijri($jd)
   {
       $jd = $jd - 1948440 + 10632;
       $n  = (int)(($jd - 1) / 10631);
       $jd = $jd - 10631 * $n + 354;
       $j  = ((int)((10985 - $jd) / 5316)) *
           ((int)(50 * $jd / 17719)) +
           ((int)($jd / 5670)) *
           ((int)(43 * $jd / 15238));
       $jd = $jd - ((int)((30 - $j) / 15)) *
           ((int)((17719 * $j) / 50)) -
           ((int)($j / 16)) *
           ((int)((15238 * $j) / 43)) + 29;
       $m  = (int)(24 * $jd / 709);
       $d  = $jd - (int)(709 * $m / 24);
       $y  = 30*$n + $j - 30;
       return array($m, $d, $y);
   }
   # Hijri To Julian Day Count
   function HijriToJD($y, $m, $d)
   {
       return 0; 

   }
}

function jd_to_cal($y, $m, $d){
	$jd = ((11 * $y + 3) / 30) + 354 * $y + 30 * $m - (($m - 1) / 2) + $d + 1948440 - 385;
    //
    // get the date from the Julian day number
    //
    $intgr   = floor($jd);
    $frac    = $jd - $intgr;
    $gregjd  = 2299161;
    if( $intgr >= $gregjd ) {                //Gregorian calendar correction
        $tmp = floor( ( ($intgr - 1867216) - 0.25 ) / 36524.25 );
        $j1 = $intgr + 1 + $tmp - floor(0.25*$tmp);
    } else
        $j1 = $intgr;

    //correction for half day offset
    $dayfrac = $frac + 0.5;
    if( $dayfrac >= 1.0 ) {
        $dayfrac -= 1.0;
        ++$j1;
    }

    $j2 = $j1 + 1524;
    $j3 = floor( 6680.0 + ( ($j2 - 2439870) - 122.1 )/365.25 );
    $j4 = floor($j3*365.25);
    $j5 = floor( ($j2 - $j4)/30.6001 );

    $d = floor($j2 - $j4 - floor($j5*30.6001));
    $m = floor($j5 - 1);
    if( $m > 12 ) $m -= 12;
    $y = floor($j3 - 4715);
    if( $m > 2 )   --$y;
    if( $y <= 0 )  --$y;

    //
    // get time of day from day fraction
    //
    $hr  = floor($dayfrac * 24.0);
    $mn  = floor(($dayfrac*24.0 - $hr)*60.0);
         $f  = (($dayfrac*24.0 - $hr)*60.0 - $mn)*60.0;
    $sc  = floor($f);
         $f -= $sc;
    if( $f > 0.5 ) ++$sc;
    if( $sc == 60 ) {
        $sc = 0;
        ++$mn;
    }
    if( $mn == 60 )  {
        $mn = 0;
        ++$hr;
    }
    if( $hr == 24 )  {
        $hr = 0;
        ++$d;            //this could cause a bug, but probably will never happen in practice
    }

    if( $y < 0 )
         $y = -$y;
	
	return array($y, $m, $d);
}
$HijriCalendar = new HijriCalendar();
$hijri = $HijriCalendar->GregorianToHijri( time() );
/*************************************/
/*****************/

function Gregorian($month){
global $g_month_name;
return $g_month_name[$month];
}

function nuketimes($time){
	global $datetype, $j_month_name, $A_month_name, $g_month_name, $j_week_name, $A_week_name, $g_week_name;
	$date = date("Y-m-d H:i:s l",$time);
	$date1  = explode(" ", $date);
	$date2  = $date1[2];
	$date1  = explode("-", $date1[0]);
	if($datetype == 1){
		$dateTimes = formatTimestamp($date);
	}elseif($datetype == 2){
		$week = date("N", $time);
		switch($week)
		{
			case "1":
				$weekname = $A_week_name[1];
				break;
			case "2":
				$weekname = $A_week_name[2];
				break;
			case "3":
				$weekname = $A_week_name[3];
				break;
			case "4":
				$weekname = $A_week_name[4];
				break;
			case "5":
				$weekname = $A_week_name[5];
				break;
			case "6":
				$weekname = $A_week_name[6];
				break;
			case "7":
				$weekname = $A_week_name[7];
				break;
		}
		$dateTimes = HijriCalendar::GregorianToHijri($time);
		$dateTimes = $weekname.' '.$dateTimes[1].' '.HijriCalendar::monthName($dateTimes[0]).' '.$dateTimes[2];
	}else{
		$mon=intval($date1[1]);
		$dateTimes = $date2." ".$date1[2]." ".Gregorian($mon)." ".$date1[0];
	}	
	return $dateTimes;
}

function all_to_gregorian($year, $month, $day){
	global $datetype;
	if($datetype == 1){
		$dateTimes = jalali_to_gregorian($year, $month, $day);
	}elseif($datetype == 2){
		$dateTimes = jd_to_cal($year, $month, $day);
	}else{
		$dateTimes = array($year,$month,$day);
	}
	return $dateTimes;
}
///////////////////////////////// MTSN Code Start
$resultmtsn = $db->sql_query("SELECT * FROM ".$prefix."_mtsn_config");
$rowmtsn = $db->sql_fetchrow($resultmtsn);
function mtsn() {
global $db , $prefix;
@require_once("mtsn/mtsn_injection.php");
if ($_SERVER["QUERY_STRING"] != ""){
    $sql = new sql_inject("log.txt",TRUE,"mtsn.php");
    $sql->test($_SERVER["QUERY_STRING"]);
}
}
$rowmtsnck = stripslashes($rowmtsn['status']);
if ($rowmtsnck == "1")
{
@mtsn();

} 
$ipbanx = stripslashes($rowmtsn['block_ip']);
if ($ipbanx =="1"){
$ip = $_SERVER['REMOTE_ADDR'];
if ($ip != "127.0.0.1" AND !is_admin($admin)) {
$ip = addslashes($ip);
$numrow = $db->sql_numrows($db->sql_query("SELECT id FROM ".$prefix."_mtsn_ipban WHERE ipaddress='$ip'"));
if ($numrow != 0) {
	echo "<br><br><center><img src='images/mtsn/mtsn.gif'><br><br><b><body bgcolor='#000066' style='font-family:arial; color:#ffffff; cursor:default;'>You have been banned by the MTSN</b></center>";
	die();
}
}
}
///////////////////////////////// MTSN Code End


/**************************************/
/* Ajax Rating                        */
/* ===================================*/
/* Author: Mohsen Sharea [Mohsenweb]  */
/* http://www.phpnuke.ir              */
/**************************************/
$unit_rating_size = 25; //Rating Cell Size
function rating_load($sid){
	global $prefix, $db, $ratecookie, $r_options, $unit_rating_size, $user, $votetype;
	$ip = $_SERVER['REMOTE_ADDR'];
	if(is_user($user)){
		if (!is_array($user)) {
			$user2 = base64_decode($user);
			$user2 = addslashes($user2);
			$user2 = explode(":", $user2);
			$uname = $user2[1];
		}
	}else{
		$uname = $user[1];
	}
	$num = $db->sql_numrows($db->sql_query("SELECT * FROM ".$prefix."_stories_score WHERE(sid='$sid' AND (rating_ip='$ip' OR username = '$uname'))"));
	if($num != 0)
	{
		$content = static_rate($sid);
		return $content;
		exit;
	}
	if(isset($ratecookie))
	{
		$rcookie = base64_decode($ratecookie);
		$rcookie = addslashes($rcookie);
		$r_cookie = explode(":", $rcookie);
	}
	for ($i=0; $i < sizeof($r_cookie); $i++) {
		if ($r_cookie[$i] == $sid) {
			$a = 1;
		}
	}
	if($a == 1)
	{
		$content = static_rate($sid);
		return $content;
		exit;
	}else
	{
		$query = $db->sql_query("SELECT * FROM ".$prefix."_stories WHERE sid='$sid'");
		$row = $db->sql_fetchrow($query);
		$score = $row['score'];
		$ratings = $row['ratings'];
		$titleff = filter($row['title'], "nohtml");
		if($score != 0)
		{
		$rated = round($score / $ratings);
		}else
		{
			$rated = 0;
		}
		$width_rate = $rated *$unit_rating_size;
		if($votetype == 0){
		$content .= "<div id=\"unit_long".$sid."\">\n";
		$content .= "<ul id=\"unit_ul".$sid."\" class=\"unit-rating\" title=\"$score امتياز از $ratings راي\">\n";
		//$content .= "<li class=\"current-rating\" style=\"width:".$width_rate."px;\"></li>\n";
		$content .= "<li><a href=\"#1\" title=\"رأي مثبت به $titleff\" onclick=\"submitRate('".$sid."','1'); return false;\" class=\"r1-unit\"></a></li>\n";
		$content .= "<li><a class=\"r2-unit\">$score</a></li>\n";
		$content .= "<li><a href=\"#2\" title=\"رأي منفي به $titleff\" onclick=\"submitRate('".$sid."','-1'); return false;\" class=\"r3-unit\"></a></li>\n";
		$content .= "</ul>\n";
		$content .= "</div>\n";
		}else{
		$content .= "<div id=\"unit_long".$sid."\">\n";
		$content .= "<ul id=\"unit_ul".$sid."\" class=\"unit-rating2\" title=\"$score امتياز از $ratings راي\">\n";
		$content .= "<li class=\"current-rating2\" style=\"width:".$width_rate."px;\"></li>\n";
		$content .= "<li><a href=\"#1\" onclick=\"submitRate('".$sid."','1'); return false;\" class=\"r1-unit2\"></a></li>\n";
		$content .= "<li><a href=\"#2\" onclick=\"submitRate('".$sid."','2'); return false;\" class=\"r2-unit2\"></a></li>\n";
		$content .= "<li><a href=\"#3\" onclick=\"submitRate('".$sid."','3'); return false;\" class=\"r3-unit2\"></a></li>\n";
		$content .= "<li><a href=\"#4\" onclick=\"submitRate('".$sid."','4'); return false;\" class=\"r4-unit2\"></a></li>\n";
		$content .= "<li><a href=\"#5\" onclick=\"submitRate('".$sid."','5'); return false;\" class=\"r5-unit2\"></a></li>\n";
		$content .= "</ul>\n";
		$content .= "</div>\n";
		}
		return $content;
		exit;
	}
}

function static_rate($sid){
	global $db,$prefix,$unit_rating_size,$votetype;
	$query = $db->sql_query("SELECT * FROM ".$prefix."_stories WHERE sid='$sid'");
	$row = $db->sql_fetchrow($query);
	$score = $row['score'];
	$ratings = $row['ratings'];
	$rate = round($score / $ratings);
	$rate_width = @number_format($rate)*$unit_rating_size;
	if($votetype == 0){
	$content .= "<div id=\"unit_long".$sid."\">\n";
	$content .= "<ul class=\"unit-rating\" title=\"$score امتياز از $ratings راي\">";
	//$content .= "<li class=\"current-rating\" style=\"width:".$rate_width."px;\"></li>";
	$content .= "<li><a class=\"r1-unit\"></a></li>";
	$content .= "<li><a class=\"r2-unit\">$score</a></li>\n";
	$content .= "<li><a class=\"r3-unit\"></a></li>";
	$content .= "</ul>";
	$content .= "</div>";
	}else{
	$content .= "<div id=\"unit_long".$sid."\">\n";
	$content .= "<ul class=\"unit-rating2\" title=\"$score امتياز از $ratings راي\">";
	$content .= "<li class=\"current-rating2\" style=\"width:".$rate_width."px;\"></li>";
	$content .= "<li class=\"r1-unit2\"></li>";
	$content .= "<li class=\"r2-unit2\"></li>";
	$content .= "<li class=\"r3-unit2\"></li>";
	$content .= "<li class=\"r4-unit2\"></li>";
	$content .= "<li class=\"r5-unit2\"></li>";
	$content .= "</ul>";
	$content .= "</div>";
	}
	return $content;
}

function SubmitNewsRate($sid,$score){
	global $prefix, $db, $ratecookie, $r_options, $unit_rating_size,$user,$votetype;
	header("Cache-Control: no-cache");
	header("Pragma: nocache");
	$score = intval($score);
	$sid = intval($sid);
	if ($score) {
		if ($score > 5) { $score = 5; }
		if ($score < (-1)) { $score = 0; }
		if($votetype == 1){
		if ($score < 1) { $score = 1; }
		if ($score != 1 AND $score != 2 AND $score != 3 AND $score != 4 AND $score != 5) {
			die();
		}
		}
		$ip = $_SERVER['REMOTE_ADDR'];
			if(is_user($user)){
				if (!is_array($user)) {
					$user2 = base64_decode($user);
					$user2 = addslashes($user2);
					$user2 = explode(":", $user2);
					$uname = $user2[1];
				}
			}
		$num = $db->sql_numrows($db->sql_query("SELECT * FROM ".$prefix."_stories_score WHERE(sid='$sid' AND (rating_ip='$ip' OR username = '$uname'))"));
		if ($num != 0)
		{
			die();
		}
		if (isset($ratecookie))
		{
			$rcookie = base64_decode($ratecookie);
			$rcookie = addslashes($rcookie);
			$r_cookie = explode(":", $rcookie);
		}
		$a = 0;
		for ($i=0; $i < sizeof($r_cookie); $i++) {
			if ($r_cookie[$i] == $sid)
			{
				$a = 1;
			}
		}
		if ($a == 1)
		{
			die();
		}else
		{
			$ip = $_SERVER['REMOTE_ADDR'];
			if(is_user($user)){
				if (!is_array($user)) {
						$user2 = base64_decode($user);
						$user2 = addslashes($user2);
						$user2 = explode(":", $user2);
						$uname = $user2[1];
						$gust = 0;
				}
			}else{
				$uname = $ip;
				$gust = 1;
			}
			$result = $db->sql_query("update ".$prefix."_stories set score=score+$score, ratings=ratings+1 where sid='$sid'");
			$result = $db->sql_query("INSERT INTO ".$prefix."_stories_score (sid, rating_ip, score, username, gust) VALUES ('$sid', '$ip', '$score', '$uname', '$gust')");
			//$info = base64_encode("$rcookie$sid:");
			//nuke_set_cookie("ratecookie","",time()+86400);
			update_points(7);

			$query = $db->sql_query("SELECT * FROM ".$prefix."_stories WHERE sid='$sid'");
			$row = $db->sql_fetchrow($query);
			$new_score = $row['score'];
			$new_ratings = $row['ratings'];
			$new_rate = round($new_score / $new_ratings);
			
			$new_back = array();
			$rate_width = @number_format($new_rate)*$unit_rating_size;
			if($votetype == 0){
			$new_back[] .= "<ul class=\"unit-rating\" title=\"$new_score امتياز از $new_ratings راي\">";
			//$new_back[] .= "<li class=\"current-rating\" style=\"width:".$rate_width."px;\"></li>";
			$new_back[] .= "<li><a class=\"r1-unit\"></a></li>";
			$new_back[] .= "<li><a class=\"r2-unit\">$new_score</a></li>\n";
			$new_back[] .= "<li><a class=\"r3-unit\"></a></li>";
			$new_back[] .= "</ul>";
			}else{
			$new_back[] .= "<div id=\"unit_long".$sid."\">\n";			
			$new_back[] .= "<ul class=\"unit-rating2\" title=\"$new_score امتياز از $new_ratings راي\">";
			$new_back[] .= "<li class=\"current-rating2\" style=\"width:".$rate_width."px;\"></li>";
			$new_back[] .= "<li class=\"r1-unit2\"></li>";
			$new_back[] .= "<li class=\"r2-unit2\"></li>";
			$new_back[] .= "<li class=\"r3-unit2\"></li>";
			$new_back[] .= "<li class=\"r4-unit2\"></li>";
			$new_back[] .= "<li class=\"r5-unit2\"></li>";
			$new_back[] .= "</ul>";
			$new_back[] .= "</div>";
			}
			$allnewback = join("\n", $new_back);
			
			$output = "unit_long$sid|$allnewback";
			echo $output;
		}
	}
	die();
}

function rating_load2($sid){
	global $prefix, $db, $ratecookie, $r_options, $unit_rating_size, $votetype, $user;
	$ip = $_SERVER['REMOTE_ADDR'];
	if(is_user($user)){
		if (!is_array($user)) {
			$user2 = base64_decode($user);
			$user2 = addslashes($user2);
			$user2 = explode(":", $user2);
			$uname = $user2[1];
		}
	}else{
		$uname = $user[1];
	}
	$num = $db->sql_numrows($db->sql_query("SELECT * FROM ".$prefix."_products_score WHERE(sid='$sid' AND (rating_ip='$ip' OR username = '$uname'))"));
	if($num != 0)
	{
		$content = static_rate2($sid);
		return $content;
		exit;
	}
	if(isset($ratecookie))
	{
		$rcookie = base64_decode($ratecookie);
		$rcookie = addslashes($rcookie);
		$r_cookie = explode(":", $rcookie);
	}
	for ($i=0; $i < sizeof($r_cookie); $i++) {
		if ($r_cookie[$i] == $sid) {
			$a = 1;
		}
	}
	if($a == 1)
	{
		$content = static_rate2($sid);
		return $content;
		exit;
	}else
	{
		$query = $db->sql_query("SELECT * FROM ".$prefix."_products WHERE sid='$sid'");
		$row = $db->sql_fetchrow($query);
		$score = $row['score'];
		$ratings = $row['ratings'];
		$titleff = filter($row['title'], "nohtml");
		if($score != 0)
		{
		$rated = round($score / $ratings);
		}else
		{
			$rated = 0;
		}
		$width_rate = $rated *$unit_rating_size;
		if($votetype == 0){
		$content .= "<div id=\"unit_long".$sid."\">\n";
		$content .= "<ul id=\"unit_ul".$sid."\" class=\"unit-rating\" title=\"$score امتياز از $ratings راي\">\n";
		//$content .= "<li class=\"current-rating\" style=\"width:".$width_rate."px;\"></li>\n";
		$content .= "<li><a href=\"#1\" title=\"راي مثبت به $titleff\" onclick=\"submitRate2('".$sid."','1'); return false;\" class=\"r1-unit\"></a></li>\n";
		$content .= "<li><a class=\"r2-unit\">$score</a></li>\n";
		$content .= "<li><a href=\"#2\" title=\"رأی منفي به $titleff\" onclick=\"submitRate2('".$sid."','-1'); return false;\" class=\"r3-unit\"></a></li>\n";
		$content .= "</ul>\n";
		$content .= "</div>\n";
		}else{
		$content .= "<div id=\"unit_long".$sid."\">\n";
		$content .= "<ul id=\"unit_ul".$sid."\" class=\"unit-rating2\" title=\"$score امتياز از $ratings راي\">\n";
		$content .= "<li class=\"current-rating2\" style=\"width:".$width_rate."px;\"></li>\n";
		$content .= "<li><a href=\"#1\" onclick=\"submitRate2('".$sid."','1'); return false;\" class=\"r1-unit2\"></a></li>\n";
		$content .= "<li><a href=\"#2\" onclick=\"submitRate2('".$sid."','2'); return false;\" class=\"r2-unit2\"></a></li>\n";
		$content .= "<li><a href=\"#3\" onclick=\"submitRate2('".$sid."','3'); return false;\" class=\"r3-unit2\"></a></li>\n";
		$content .= "<li><a href=\"#4\" onclick=\"submitRate2('".$sid."','4'); return false;\" class=\"r4-unit2\"></a></li>\n";
		$content .= "<li><a href=\"#5\" onclick=\"submitRate2('".$sid."','5'); return false;\" class=\"r5-unit2\"></a></li>\n";
		$content .= "</ul>\n";
		$content .= "</div>\n";
		}
		return $content;
		exit;
	}
}

function static_rate2($sid){
	global $db,$prefix,$unit_rating_size,$votetype;
	$query = $db->sql_query("SELECT * FROM ".$prefix."_products WHERE sid='$sid'");
	$row = $db->sql_fetchrow($query);
	$score = $row['score'];
	$ratings = $row['ratings'];
	$rate = round($score / $ratings);
	$rate_width = @number_format($rate)*$unit_rating_size;
	if($votetype == 0){
	$content .= "<div id=\"unit_long".$sid."\">\n";
	$content .= "<ul class=\"unit-rating\" title=\"$score امتياز از $ratings راي\">";
	//$content .= "<li class=\"current-rating\" style=\"width:".$rate_width."px;\"></li>";
	$content .= "<li><a class=\"r1-unit\"></a></li>";
	$content .= "<li><a class=\"r2-unit\">$score</a></li>\n";
	$content .= "<li><a class=\"r3-unit\"></a></li>";
	$content .= "</ul>";
	$content .= "</div>";
	}else{
	$content .= "<div id=\"unit_long".$sid."\">\n";
	$content .= "<ul class=\"unit-rating2\" title=\"$score امتياز از $ratings راي\">";
	$content .= "<li class=\"current-rating2\" style=\"width:".$rate_width."px;\"></li>";
	$content .= "<li class=\"r1-unit2\"></li>";
	$content .= "<li class=\"r2-unit2\"></li>";
	$content .= "<li class=\"r3-unit2\"></li>";
	$content .= "<li class=\"r4-unit2\"></li>";
	$content .= "<li class=\"r5-unit2\"></li>";
	$content .= "</ul>";
	$content .= "</div>";
	}
	return $content;
}

function SubmitNewsRate2($sid,$score){
	global $prefix, $db, $ratecookie, $r_options, $unit_rating_size, $user,$votetype;
	header("Cache-Control: no-cache");
	header("Pragma: nocache");
	$score = intval($score);
	$sid = intval($sid);
	if ($score) {
		if ($score > 5) { $score = 5; }
		if ($score < (-1)) { $score = 0; }
		if($votetype == 1){
		if ($score < 1) { $score = 1; }
		if ($score != 1 AND $score != 2 AND $score != 3 AND $score != 4 AND $score != 5) {
			die();
		}
		}
		$ip = $_SERVER['REMOTE_ADDR'];
			if(is_user($user)){
				if (!is_array($user)) {
					$user2 = base64_decode($user);
					$user2 = addslashes($user2);
					$user2 = explode(":", $user2);
					$uname = $user2[1];
				}
			}
		$num = $db->sql_numrows($db->sql_query("SELECT * FROM ".$prefix."_products_score WHERE sid='$sid' AND rating_ip='$ip'"));
		if ($num != 0)
		{
			die();
		}
		if (isset($ratecookie))
		{
			$rcookie = base64_decode($ratecookie);
			$rcookie = addslashes($rcookie);
			$r_cookie = explode(":", $rcookie);
		}
		for ($i=0; $i < sizeof($r_cookie); $i++) {
			if ($r_cookie[$i] == $sid)
			{
				$a = 1;
			}
		}
		if ($a == 1)
		{
			die();
		}else
		{
			$ip = $_SERVER['REMOTE_ADDR'];
			if(is_user($user)){
				if (!is_array($user)) {
					$user2 = base64_decode($user);
					$user2 = addslashes($user2);
					$user2 = explode(":", $user2);
					$uname = $user2[1];
					$gust = 0;
				}
			}else{
				$uname = $ip;
				$gust = 1;
			}
			$result = $db->sql_query("update ".$prefix."_products set score=score+$score, ratings=ratings+1 where sid='$sid'");
			$result = $db->sql_query("INSERT INTO ".$prefix."_products_score (sid, rating_ip, score, username, gust) VALUES ('$sid', '$ip', '$score', '$uname', '$gust')");
			$info = base64_encode("$rcookie$sid:");
			nuke_set_cookie("ratecookie","$info",time()+86400);
			update_points(7);

			$query = $db->sql_query("SELECT * FROM ".$prefix."_products WHERE sid='$sid'");
			$row = $db->sql_fetchrow($query);
			$new_score = $row['score'];
			$new_ratings = $row['ratings'];
			$new_rate = round($new_score / $new_ratings);
			
			$new_back = array();
			$rate_width = @number_format($new_rate)*$unit_rating_size;
			if($votetype == 0){
			$new_back[] .= "<ul class=\"unit-rating\" title=\"$new_score امتياز از $new_ratings راي\">";
			//$new_back[] .= "<li class=\"current-rating\" style=\"width:".$rate_width."px;\"></li>";
			$new_back[] .= "<li><a class=\"r1-unit\"></a></li>";
			$new_back[] .= "<li><a class=\"r2-unit\">$new_score</a></li>\n";
			$new_back[] .= "<li><a class=\"r3-unit\"></a></li>";
			$new_back[] .= "</ul>";
			}else{
			$new_back[] .= "<div id=\"unit_long".$sid."\">\n";			
			$new_back[] .= "<ul class=\"unit-rating2\" title=\"$new_score امتياز از $new_ratings راي\">";
			$new_back[] .= "<li class=\"current-rating2\" style=\"width:".$rate_width."px;\"></li>";
			$new_back[] .= "<li class=\"r1-unit2\"></li>";
			$new_back[] .= "<li class=\"r2-unit2\"></li>";
			$new_back[] .= "<li class=\"r3-unit2\"></li>";
			$new_back[] .= "<li class=\"r4-unit2\"></li>";
			$new_back[] .= "<li class=\"r5-unit2\"></li>";
			$new_back[] .= "</ul>";
			$new_back[] .= "</div>";
			}
			
			$allnewback = join("\n", $new_back);
			
			$output = "unit_long$sid|$allnewback";
			echo $output;
		}
	}
	die();	
}

function rating_load3($pid){
	global $prefix, $db, $unit_rating_size, $votetype, $user;
	$ip = $_SERVER['REMOTE_ADDR'];
	if(is_user($user)){
		if (!is_array($user)) {
			$user2 = base64_decode($user);
			$user2 = addslashes($user2);
			$user2 = explode(":", $user2);
			$uname = $user2[1];
		}
	}else{
		$uname = $user[1];
	}	
	$sresult = $db->sql_query("SELECT * FROM ".$prefix."_pages_score WHERE(pid='$pid'  AND (rating_ip='$ip' OR username = '$uname'))");
	$num = $db->sql_numrows($sresult);
	if($num != 0)
	{
		$contentd = static_rate3($pid);
		return $contentd;
		exit;
	}else{
		$query = $db->sql_query("SELECT * FROM ".$prefix."_pages WHERE pid='$pid'");
		$row = $db->sql_fetchrow($query);
		$score = intval($row['score']);
		$ratings = intval($row['ratings']);
		$titleff = filter($row['title'], "nohtml");
		if($score != 0)
		{
		$rated = round($score / $ratings);
		}else
		{
			$rated = 0;
		}
		$width_rate = $rated *$unit_rating_size;
		if($votetype == 0){
		$content .= "<div id=\"unit_long".$pid."\">\n";
		$content .= "<ul id=\"unit_ul".$pid."\" class=\"unit-rating\" title=\"$score امتياز از $ratings راي\">\n";
		//$content .= "<li class=\"current-rating\" style=\"width:".$width_rate."px;\"></li>\n";
		$content .= "<li><a href=\"#1\" title=\"راي مثبت به $titleff\" onclick=\"submitRate3('".$pid."','1'); return false;\" class=\"r1-unit\"></a></li>\n";
		$content .= "<li><a class=\"r2-unit\">$score</a></li>\n";
		$content .= "<li><a href=\"#2\" title=\"رأی منفي به $titleff\" onclick=\"submitRate3('".$pid."','-1'); return false;\" class=\"r3-unit\"></a></li>\n";
		$content .= "</ul>\n";
		$content .= "</div>\n";
		}else{
		$content .= "<div id=\"unit_long".$pid."\">\n";
		$content .= "<ul id=\"unit_ul".$pid."\" class=\"unit-rating2\" title=\"$score امتياز از $ratings راي\">\n";
		$content .= "<li class=\"current-rating2\" style=\"width:".$width_rate."px;\"></li>\n";
		$content .= "<li><a href=\"#1\" onclick=\"submitRate3('".$pid."','1'); return false;\" class=\"r1-unit2\"></a></li>\n";
		$content .= "<li><a href=\"#2\" onclick=\"submitRate3('".$pid."','2'); return false;\" class=\"r2-unit2\"></a></li>\n";
		$content .= "<li><a href=\"#3\" onclick=\"submitRate3('".$pid."','3'); return false;\" class=\"r3-unit2\"></a></li>\n";
		$content .= "<li><a href=\"#4\" onclick=\"submitRate3('".$pid."','4'); return false;\" class=\"r4-unit2\"></a></li>\n";
		$content .= "<li><a href=\"#5\" onclick=\"submitRate3('".$pid."','5'); return false;\" class=\"r5-unit2\"></a></li>\n";
		$content .= "</ul>\n";
		$content .= "</div>\n";
		}
		return $content;
		exit;
	}
}

function static_rate3($pid){
	global $db,$prefix,$unit_rating_size,$votetype;
	$query = $db->sql_query("SELECT * FROM ".$prefix."_pages WHERE pid='$pid'");
	$row = $db->sql_fetchrow($query);
	$score = $row['score'];
	$ratings = $row['ratings'];
	$rate = round($score / $ratings);
	$rate_width = @number_format($rate)*$unit_rating_size;
	if($votetype == 0){
	$content .= "<div id=\"unit_long".$pid."\">\n";
	$content .= "<ul class=\"unit-rating\" title=\"$score امتياز از $ratings راي\">";
	//$content .= "<li class=\"current-rating\" style=\"width:".$rate_width."px;\"></li>";
	$content .= "<li><a class=\"r1-unit\"></a></li>";
	$content .= "<li><a class=\"r2-unit\">$score</a></li>\n";
	$content .= "<li><a class=\"r3-unit\"></a></li>";
	$content .= "</ul>";
	$content .= "</div>";
	}else{
	$content .= "<div id=\"unit_long".$bid."\">\n";
	$content .= "<ul class=\"unit-rating2\" title=\"$score امتياز از $ratings راي\">";
	$content .= "<li class=\"current-rating2\" style=\"width:".$rate_width."px;\"></li>";
	$content .= "<li class=\"r1-unit2\"></li>";
	$content .= "<li class=\"r2-unit2\"></li>";
	$content .= "<li class=\"r3-unit2\"></li>";
	$content .= "<li class=\"r4-unit2\"></li>";
	$content .= "<li class=\"r5-unit2\"></li>";
	$content .= "</ul>";
	$content .= "</div>";
	}
	return $content;
}

function SubmitNewsRate3($pid,$score){
	global $prefix, $db, $ratecookie, $r_options, $unit_rating_size, $user,$votetype;
	header("Cache-Control: no-cache");
	header("Pragma: nocache");
	$score = intval($score);
	$pid = intval($pid);
	if ($score) {
		if ($score > 5) { $score = 5; }
		if ($score < (-1)) { $score = 0; }
		if($votetype == 1){
		if ($score < 1) { $score = 1; }
		if ($score != 1 AND $score != 2 AND $score != 3 AND $score != 4 AND $score != 5) {
			die();
		}
		}
		$ip = $_SERVER['REMOTE_ADDR'];
			if(is_user($user)){
				if (!is_array($user)) {
					$user2 = base64_decode($user);
					$user2 = addslashes($user2);
					$user2 = explode(":", $user2);
					$uname = $user2[1];
				}
			}		
		$num = $db->sql_numrows($db->sql_query("SELECT * FROM ".$prefix."_pages_score WHERE pid='$pid' AND (rating_ip='$ip' OR username = '$uname')"));
		if ($num != 0)
		{
			die();
		}else
		{
			$ip = $_SERVER['REMOTE_ADDR'];
			if(is_user($user)){
				if (!is_array($user)) {
					$user2 = base64_decode($user);
					$user2 = addslashes($user2);
					$user2 = explode(":", $user2);
					$uname = $user2[1];
					$gust = 0;
				}
			}else{
				$uname = $ip;
				$gust = 1;
			}
			$result = $db->sql_query("update ".$prefix."_pages set score=score+$score, ratings=ratings+1 where pid='$pid'");
			$result = $db->sql_query("INSERT INTO ".$prefix."_pages_score (pid, rating_ip, score, username, gust) VALUES ('$pid', '$ip', '$score', '$uname', '$gust')");
			//$info = base64_encode("$rcookie$pid:");
			//nuke_set_cookie("ratecookie","$info",time()+86400);
			update_points(7);

			$query = $db->sql_query("SELECT * FROM ".$prefix."_pages WHERE pid='$pid'");
			$row = $db->sql_fetchrow($query);
			$new_score = intval($row['score']);
			$new_ratings = intval($row['ratings']);
			$new_rate = round($new_score / $new_ratings);
			
			$new_back = array();
			$rate_width = @number_format($new_rate)*$unit_rating_size;
			if($votetype == 0){
			$new_back[] .= "<ul class=\"unit-rating\" title=\"$new_score امتياز از $new_ratings راي\">";
			//$new_back[] .= "<li class=\"current-rating\" style=\"width:".$rate_width."px;\"></li>";
			$new_back[] .= "<li><a class=\"r1-unit\"></a></li>";
			$new_back[] .= "<li><a class=\"r2-unit\">$new_score</a></li>\n";
			$new_back[] .= "<li><a class=\"r3-unit\"></a></li>";
			$new_back[] .= "</ul>";
			}else{
			$new_back[] .= "<div id=\"unit_long".$pid."\">\n";			
			$new_back[] .= "<ul class=\"unit-rating2\" title=\"$new_score امتياز از $new_ratings راي\">";
			$new_back[] .= "<li class=\"current-rating2\" style=\"width:".$rate_width."px;\"></li>";
			$new_back[] .= "<li class=\"r1-unit2\"></li>";
			$new_back[] .= "<li class=\"r2-unit2\"></li>";
			$new_back[] .= "<li class=\"r3-unit2\"></li>";
			$new_back[] .= "<li class=\"r4-unit2\"></li>";
			$new_back[] .= "<li class=\"r5-unit2\"></li>";
			$new_back[] .= "</ul>";
			$new_back[] .= "</div>";
			}
			
			$allnewback = join("\n", $new_back);
			
			$output = "unit_long$pid|$allnewback";
			echo $output;
		}
	}
	die();	
}

function clean_pagination($total_rows, $entries_per_page, $current_page, $link_to){
	global $align;
	$total_page = ceil($total_rows / $entries_per_page);
	$str_page  = (strpos($link_to, "?") === false) ? "?page" : "&amp;page";
	$page = $current_page-3;
	$upper =$current_page+3;

	if ($page <=0) {
		$page=1;
	}
	if ($upper >$total_page) {
		$upper =$total_page;
	}

  	if ($upper-$page <6){

		//We know that one of the page has maxed out
		//check which one it is
		//echo "$upper >=$maxPage<br>";
		if ($upper >=$total_page){
			//the upper end has maxed, put more on the front end
			//echo "to begining<br>";
			$dif =$total_page-$page;
			//echo "$dif<br>";
				if ($dif==3){
					$page=$page-3;
				}elseif ($dif==4){
					$page=$page-2;
				}elseif ($dif==5){
					$page=$page-1;
				}
		}elseif ($page <1) {
			//its the low end, add to upper end
			//echo "to upper<br>";
			$dif =$upper-1;

			if ($dif==3){
				$upper=$upper+3;
			}elseif ($dif==4){
				$upper=$upper+2;
			}elseif ($dif==5){
				$upper=$upper+1;
			}
		}
	}	
	if ($page <=0) {
		$page=1;
	}
	if($align == "rtl"){
	$dirrr="right";
	}else{
	$dirrr="left";
	}
 	for($page; $page <=  $upper; $page++) {
		if ($page == $current_page){
			$nav .= "<span class=\"current current-page\" style=\"float:$dirrr\">$page</span>";
		}else{
			$nav .= "<a href=\"$link_to$str_page=$page\" style=\"float:$dirrr\">$page</a>";
		}
	}	  
	if ($current_page > 1){
		$ppage  = $current_page - 1;
		$prev  = "<a href=\"$link_to$str_page=$ppage\" style=\"float:$dirrr\">&lt;- "._MT_PREV2."</a> ";
		$first = "<a href=\"$link_to\" style=\"float:$dirrr\">&lt;- "._MT_FIRST."</a> ";
	}else{
		$prev  = "<span class=\"disabled\" style=\"float:$dirrr\">&lt;- "._MT_PREV2."</span> ";
		$first = "<span class=\"disabled\" style=\"float:$dirrr\">&lt;- "._MT_FIRST."</span> ";
	}	
	if ($current_page < $total_page AND $upper <= $total_page) {
		$page = $current_page + 1;
		$next = " <a href=\"$link_to$str_page=$page\" style=\"float:$dirrr\"> "._MT_NEXT2." -&gt;</a>";
		$last = " <a href=\"$link_to$str_page=$total_page\" style=\"float:$dirrr\">"._MT_END." -&gt;</a>";
	} else {
		$next = " <span class=\"disabled\" style=\"float:$dirrr\">"._MT_NEXT2." -&gt;</span>";
		$last = " <span class=\"disabled\" style=\"float:$dirrr\">"._MT_END." -&gt;</span>";
	}	

	$paginate_links = "<div align=\"center\"><table align=\"center\" border=\"0\"><tr><td align=\"center\">".$first . $prev . $nav . $next . $last."</td></tr></table></div>";
	
if($total_rows != '0'){
  print $paginate_links;
  }
}

$handle=@opendir('modules');
while ($mfile = @readdir($handle)) { if ( (!@ereg("[.]",$mfile)) ) { $moduleslist .= "$mfile "; } }
@closedir($handle);
$moduleslist = @explode(" ", $moduleslist);
@sort($moduleslist);
foreach($moduleslist as $modulename) {
	if(file_exists("modules/$modulename/config_function.php")){
		define("CONFIG_FUNCTIONS_FILE", true);
		@include("modules/$modulename/config_function.php");
	}
}

$row = $db->sql_fetchrow($db->sql_query("SELECT main_module from ".$prefix."_main"));
$gname = $row['main_module'];
if($name != ""){
	$gname = $name;
}

///////////////////////////////////////////////////////////
if ($gtset == "1") {
	$nextGenOb = 1; //<-- NExtGEn On or Off, 1=On, 0=Off
	$nextGenDebug = 0; //<-- Turn Debugging On or Off 1=On,
	$nextGenMainPath = "modules/$gname"; //<-- Name of Directory to GoogleTap
	$nextGenBlock = 0; //<-- Enable Auto-Convert on Blocks
	$nextGenAdmin = is_admin($admin); //<-- Do NOT Touch!

	function nextGenTap($nextGenHead, $nextGenFoot, $nextGenContents) {
		global $prefix, $db, $admin, $nextGenOb, $nextGenDebug, $nextGenMainPath, $nextGenBlock, $nextGenAdmin;
		if($nextGenHead == 1) {     
			ob_start();
			return; 
		}             
		if ($nextGenFoot == 1) {	
			$getNextGen = ob_get_contents(); 
			$getNextGen = @preg_replace("(&(?!([a-zA-Z]{2,6}|[0-9\#]{1,6})[\;]))", "&amp;", $getNextGen); 
			$getNextGen = str_replace(array("&amp;&amp;", "&amp;middot;", "&amp;nbsp;"), array("&&", "&middot;", "&nbsp;"), $getNextGen); 
			ob_end_clean();
			$handle=opendir('modules');
			while ($mfile = readdir($handle)) { if ( (!@ereg("[.]",$mfile)) ) { $moduleslist .= "$mfile "; } }
			closedir($handle);
			$moduleslist = explode(" ", $moduleslist);
			sort($moduleslist);
			foreach($moduleslist as $modulename) {
				if(file_exists("modules/$modulename/GT-$modulename.php")){
					@include("modules/$modulename/GT-$modulename.php");
					foreach($urlin as $urlsin){
						$urlsin = str_replace("\"(?<!/)","(?<!/)",$urlsin);
						$urlsin = str_replace("\"'","'",$urlsin);
						$urlsin = str_replace('"','',$urlsin);
						$urlins[] = $urlsin;
					}
					foreach($urlout as $urlsout){
						$urlsout = str_replace("\"(?<!/)","(?<!/)",$urlsout);
						$urlsout = str_replace("\"'","'",$urlsout);
						$urlsout = str_replace('"','',$urlsout);
						$urlouts[] = $urlsout;
					}
				}
			}
			$nextGenContent = @preg_replace($urlins, $urlouts, $getNextGen);
			$nextGenContent = str_replace("&amp;","&",$nextGenContent);
			echo $nextGenContent;
			return; 
		}
	}
}//end if

function LinkToGT($link) {
	global $nukeurl, $gtset;
	if($gtset == 1){
		$getNextGen = $link; 
		$getNextGen = @preg_replace("(&(?!([a-zA-Z]{2,6}|[0-9\#]{1,6})[\;]))", "&amp;", $getNextGen); 
		$getNextGen = str_replace(array("&amp;&amp;", "&amp;middot;", "&amp;nbsp;"), array("&&", "&middot;", "&nbsp;"), $getNextGen); 
		$handle=opendir('modules');
		while ($mfile = readdir($handle)) { if ( (!@ereg("[.]",$mfile)) ) { $moduleslist .= "$mfile "; } }
		closedir($handle);
		$moduleslist = explode(" ", $moduleslist);
		sort($moduleslist);
		foreach($moduleslist as $modulename) {
			if(file_exists("modules/$modulename/GT-$modulename.php")){
				@include("modules/$modulename/GT-$modulename.php");
				foreach($urlin as $urlsin){
					$urlsin = str_replace("\"(?<!/)","(?<!/)",$urlsin);
					$urlsin = str_replace("\"'","'",$urlsin);
					$urlsin = str_replace('"','',$urlsin);
					$urlins[] = $urlsin;
				}
				foreach($urlout as $urlsout){
					$urlsout = str_replace("\"(?<!/)","(?<!/)",$urlsout);
					$urlsout = str_replace("\"'","'",$urlsout);
					$urlsout = str_replace('"','',$urlsout);
					$urlouts[] = $urlsout;
				}
			}
		}
		$nextGenContent = @preg_replace($urlins, $urlouts, $getNextGen);
		$nextGenContent = str_replace("&amp;","&",$nextGenContent);
		if(!@ereg("http://",$link)){
			$nextGenContent = $nukeurl.$nextGenContent;
		}
		return $nextGenContent; 
	}else{
		$nextGenContent = str_replace("&","&amp;",$link);
		if(!@ereg("http://",$link)){
			$nextGenContent = $nukeurl.$nextGenContent;
		}
		return $nextGenContent; 
	}
}

function codereplace($text,$sid){
global $show_links, $user, $admin,$sitename, $show_effect;
	if($show_effect == 1){
	$patterns[] = "#\<img(.*?)src=\"(.*?)\"(.*?)\>#si";
	$replacements[] = "<a href=\"$2\" onMouseOver=\"SMR_setLink(this);\" target=\"_blank\" rel=\"lightbox$sid\"><img $1 src=\"$2\" alt=\"$sitename\" onLoad=\"SMR_resize(this);\" border=\"0\" $3 /></a>";

	if($show_links == 0){
	if((is_user($user)) OR (is_admin($admin))){}else{
	$patterns[] = "#\<a (.*?)\>(.*?)</a>#si";
	$replacements[] = ""._JUST_USERS."";
	}
	}
	$text = @preg_replace($patterns, $replacements, $text);
	return $text;
	}else{
	return $text;
	}
}

function upload_image($sid,$uploaded,$tumb,$module_name){
	$target = "files/$module_name/";
	$filename = $uploaded['name'];
	$target = $target . basename($uploaded['name']) ;
	$ok=1;
	if(move_uploaded_file($uploaded['tmp_name'], $target)){
		$name = basename($uploaded['name']);
		$tar1 = "files/$module_name/";
		$tar2 = "files/$module_name/thumbs/";
		$name2 = "$sid.jpg";
		if($tumb == 1){
			echo ""._OK_UPLOAD."";
			Resize($tar1,$name,$tar2,$name2,160,160,90);
			rename ("files/$module_name/$name" , "files/$module_name/$sid.jpg");
		}else{
			rename ("files/$module_name/$name" , "files/$module_name/$sid.jpg");
			echo ""._OK_UPLOAD2."";
		}
	}else{
		echo ""._UPLOAD_ERROR."";
	}
}

function Resize($Dir,$Image,$NewDir,$NewImage,$MaxWidth,$MaxHeight,$Quality) {
  list($ImageWidth,$ImageHeight,$TypeCode)=getimagesize($Dir.$Image);
  $ImageType=($TypeCode==1?"gif":($TypeCode==2?"jpeg":
             ($TypeCode==3?"png":FALSE)));
  $CreateFunction="imagecreatefrom".$ImageType;
  $OutputFunction="image".$ImageType;
  if ($ImageType) {
    $Ratio=($ImageHeight/$ImageWidth);
    $ImageSource=$CreateFunction($Dir.$Image);
    if ($ImageWidth > $MaxWidth || $ImageHeight > $MaxHeight) {
      if ($ImageWidth > $MaxWidth) {
         $ResizedWidth=$MaxWidth;
         $ResizedHeight=$ResizedWidth*$Ratio;
      }
      else {
        $ResizedWidth=$ImageWidth;
        $ResizedHeight=$ImageHeight;
      }       
      if ($ResizedHeight > $MaxHeight) {
        $ResizedHeight=$MaxHeight;
        $ResizedWidth=$ResizedHeight/$Ratio;
      }      
      $ResizedImage=imagecreatetruecolor($ResizedWidth,$ResizedHeight);
      imagecopyresampled($ResizedImage,$ImageSource,0,0,0,0,$ResizedWidth,
                         $ResizedHeight,$ImageWidth,$ImageHeight);
    }
    else {
      $ResizedWidth=$ImageWidth;
      $ResizedHeight=$ImageHeight;     
      $ResizedImage=$ImageSource;
    }   
    $OutputFunction($ResizedImage,$NewDir.$NewImage,$Quality);
    return true;
  }   
  else
    return false;
}

function custom_headlines($url){
$meta = "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=windows-1256\">";
$style = "<style>body {font-family:Tahoma;font-size:11px;direction:rtl;text-align:justify} .rss a {text-decoration:none;color:#0000FF;} .rss a:hover{text-decoration:none;color:#FF0000;}</style>";
$rdf = parse_url($url);
$fp = fsockopen($rdf['host'], 80, $errno, $errstr, 15);
if ($fp) {
	fputs($fp, "GET " . $rdf['path'] . "?" . $rdf['query'] . " HTTP/1.0\r\n");
	fputs($fp, "HOST: " . $rdf['host'] . "\r\n\r\n");
	$string = "";
	while(!feof($fp)) {
		$pagetext = fgets($fp,228);
		$string .= chop($pagetext);
	}
	fputs($fp,"Connection: close\r\n\r\n");
	fclose($fp);
	$items = explode("</item>",$string);
	$content = "<font class=\"content\">";
	for ($i=0;$i<10;$i++) {
		$link = @ereg_replace(".*<link>","",$items[$i]);
		$link = @ereg_replace("</link>.*","",$link);
		$title2 = @ereg_replace(".*<title>","",$items[$i]);
		$title2 = @ereg_replace("</title>.*","",$title2);
		if ($items[$i] == "" AND $cont != 1) {
			$content = "";
		} else {
			if (strcmp($link,$title2) AND !empty($items[$i])) {
					$cont = 1;
					$content .= "<strong><big>&middot;</big></strong>&nbsp;<a onmouseover=\"this.style.color='#ff0000';\" onmouseout=\"this.style.color='#0000FF'\" style=\"text-align:justify;text-decoration:none;\" href=\"$link\" target=\"new\">$title2</a><br>\n";
			}
		}
	}
$content = "$meta$style$content";
return $content;	
}

}

function last_user() {
    global $db, $prefix;
    $sql = "SELECT username FROM ".$prefix."_users WHERE user_active = 1 AND user_level > 0 AND user_type != 2 ORDER BY user_id DESC LIMIT 0,1";
    list($lastuser) = $db->sql_fetchrow($db->sql_query($sql));
    return $lastuser;
}

//Total Members
function numusers() {
    global $prefix, $db;
    $sql = "SELECT COUNT(*) FROM ".$prefix."_users WHERE user_id > 1 AND user_type != 2";
    list($numrows) = $db->sql_fetchrow($db->sql_query($sql));
    $numrows = number_format($numrows);
    return $numrows;
}

//Total Waiting
function waiting_users() {
    global $prefix, $db;
    $sql = "SELECT COUNT(*) FROM ".$prefix."_users_temp";
    list($numrowswaiting) = $db->sql_fetchrow($db->sql_query($sql));
    return $numrowswaiting;
}

//New Users Today and Yesterday
function new_users() {
    global $prefix, $db;
	$nowday = mktime(0,0,0,date("m"),date("d"),date("y"));
	$yesterday = $nowday-86400;
    list($userCount[0]) = $db->sql_fetchrow($db->sql_query("SELECT COUNT(*) FROM ".$prefix."_users WHERE user_regdate > '$nowday'  AND user_type != '2'"));
    list($userCount[1]) = $db->sql_fetchrow($db->sql_query("SELECT COUNT(*) FROM ".$prefix."_users WHERE(user_regdate > '$yesterday' AND user_regdate < '$nowday' AND user_type != '2')"));
    return $userCount;
}

function czuzersinfo(){
include ("blocks/czinfo.php");
}

switch($bl){
	case"czuzersinfo":
		czuzersinfo();
	break;
}
 //Cloud Tags

function tag_used($sid,$tag)
{
	global $db,$prefix;
	
	$row = $db->sql_fetchrow($db->sql_query("SELECT notes FROM ".$prefix."_stories WHERE sid='".intval($sid)."'"));
	$story_tags = explode(':',$row['notes']);
//	return in_array($tag,$story_tags);
	return 1;
}

function num_tag_used($tag)
{
	global $db,$prefix;
	
	return $db->sql_numrows($db->sql_query("SELECT * FROM ".$prefix."_stories WHERE notes LIKE '%".mysql_escape_string($tag)."%'"));
}

function taglink($tag)
{
	global $gtset;
	if($gtset == "1"):
		$link = 'tags/'.str_replace(" ","_",$tag).'/';  
	else:
		$link = 'modules.php\?name=News&file=tags&tags='.str_replace(" ","_",$tag);
	endif;
	return $link;
}

function MT_Cloud_Tag($max_font_size = 36,$min_font_size = 12,$limit=30,$sortby='name',$order='ASC')
{
	global $db,$prefix,$nukeurl;
	
	if($order == 'DESC'): $order = 'DESC'; else: $order = 'ASC'; endif;
	if($sortby == 'count'): $sortby = 'counter'; else: $sortby = 'tag'; endif;
	$tags = array();
	$query = $db->sql_query("SELECT tag_id,tag FROM ".$prefix."_tags ORDER BY ".$sortby." ".$order." LIMIT 0,".$limit."");
	while($row = $db->sql_fetchrow($query))
	{
		$tag = $row['tag'];      //amir
                //$tag = str_replace(" ","_","$tag");
		$tags[$tag] = num_tag_used($tag);
	}
	$max = max($tags);
	$min = min($tags);
	$beetwen = $max - $min;
	if($beetwen == 0) $beetwen = 1;
	$level = ($max_font_size - $min_font_size) / $beetwen;
	$mycontent = "";
	foreach($tags as $tagname => $value)
	{
		$font_size = round($min_font_size + (($value - $min) * $level));
		$tagnamelink = @str_replace(" ","_","$tagname");
		$content .= "<a href =\"".$nukeurl.taglink($tagnamelink)."\" style=\"font-size:".$font_size."px;\">$tagname</a> ";
	}
	return $content;
}

function newslink($sid){
	global $gtset, $userurl, $prefix, $db;
	$result = $db->sql_query("SELECT sid, title, time, newsurl, topic_link FROM ".$prefix."_stories WHERE sid = '$sid'");
    $row = $db->sql_fetchrow($result);
	$sid = $row['sid'];
	$title = filter($row['title'], "nohtml");
	$newsurl = filter($row['newsurl'], "nohtml");
	$topic_link = intval($row['topic_link']);
	$time = $row['time'];
	$nutime = $time;
	$nudate = date("Y-m-d H:i:s", $time);
	global $datetype;
	$nudate1  = explode(" ", $nudate);
	$nudate1  = explode("-", $nudate1[0]);
	if($datetype == 1){
		$timelink = FormalDate2Hejri($nudate);
	}elseif($datetype == 2){
		$adateTimes = HijriCalendar::GregorianToHijri($nutime);
		$timelink = $adateTimes[1].'-'.$adateTimes[0].'-'.$adateTimes[2];
	}else{
		$timelink = $nudate1[2]."-".$nudate1[1]."-".$nudate1[0];
	}
	$newsurl = str_replace(" ", "-", $newsurl);
	$topic_result = $db->sql_query("SELECT topicname, topicimage FROM ".$prefix."_topics WHERE topicid = $topic_link");
	$torow = $db->sql_fetchrow($topic_result);
	$topicname_link = filter($torow['topicname'], "nohtml");
	$topicname_link = "$topicname_link";
	$timelink = "$timelink";
	if($newsurl == ""){
		$newsurl = str_replace(" ", "-", $title);
	}
	if($gtset == "1"){
		if($userurl == "1"){
			$story_link = "modules.php?name=News&file=article-seo&sid=$sid-$newsurl";
		}elseif ($userurl == "2") {
			$story_link = "modules.php?name=News&file=article-seo&sid=$sid-$newsurl-$timelink";
		}elseif ($userurl == "3") {
			$story_link = "modules.php?name=News&file=article-seo&sid=$sid-$newsurl-$topicname_link";
		}elseif ($userurl == "4") {
			$story_link = "modules.php?name=News&file=article-seo&sid=$sid-$topicname_link-$timelink";
		}elseif ($userurl == "5") {
			$story_link = "modules.php?name=News&file=article-seo&sid=$sid-$newsurl-$timelink-$topicname_link";
			//style 2 , door budane linke mataleb az domain asli , olaviate behtari dare
		}elseif ($userurl == "6") {
			$story_link = "$sid/$newsurl/";
		}elseif ($userurl == "7") {
			$story_link = "modules.php?name=News&file=article-seo&sid=$sid/$timelink/$newsurl/";
		}elseif ($userurl == "8") {
			$story_link = "modules.php?name=News&file=article-seo&sid=$sid/$topicname_link/$newsurl/";
		}elseif ($userurl == "9") {
			$story_link = "modules.php?name=News&file=article-seo&sid=$sid/$topicname_link/$timelink/";
		}elseif ($userurl == "10") {
			$story_link = "modules.php?name=News&file=article-seo&sid=$sid/$timelink/$topicname_link/$newsurl/";
		}
	}else {
		$title2 = addslashes($title);
		$title2 = str_replace(" ", "-", $title2);
		$story_link = "modules.php?name=News&file=article-seo&sid=$sid-$title2";
	}
	return $story_link;
} 

if(isset($_FILES['Filedata'])){
	include("includes/upload.php");
}

?>